import { TSFusionEnumeration } from "./tsfusionnode";
import { TSObject } from "./tsobject";
import { Nullable, TSUnicity } from "./types";
export type $mapCallback<T, R> = (value: T, index: number) => Nullable<R>;
export interface $mapOptions<T, R> {
    callback?: $mapCallback<T, R>;
    unicity?: Nullable<TSUnicity>;
}
export declare function $map<T, R = T>(values: Nullable<Iterable<T>>, options?: Nullable<$mapCallback<T, R> | $mapOptions<T, R>>): R[];
export declare function $arrayset<T, R = T>(values: Nullable<Iterable<T>>, callback?: Nullable<$mapCallback<T, R>>): Set<R>;
export { $arrayset as $mapset };
export declare function $includesequal<T = any>(values: Nullable<Iterable<T>>, object: any): boolean;
export declare function $includesvisual<T = any>(values: Nullable<Iterable<T>>, object: any): boolean;
export declare function $first<T = any>(values: Nullable<ArrayLike<T>>): T | undefined;
export declare function $last<T = any>(values: Nullable<ArrayLike<T>>): T | undefined;
export declare function $sum<T = any>(values: Nullable<Iterable<T>>): number | undefined;
export declare function $min<T = any>(values: Nullable<Iterable<T>>): T | undefined;
export declare function $max<T = any>(values: Nullable<Iterable<T>>): T | undefined;
export interface $averageOptions {
    countsOnlyOKItems?: boolean;
    countsOnlyDefinedItems?: boolean;
}
export declare function $average<T = any>(values: Nullable<Iterable<T>>, opts?: $averageOptions): number | undefined;
declare global {
    export interface Array<T> extends TSObject, TSFusionEnumeration {
        average: (this: T[], opts?: $averageOptions) => number | undefined;
        filteredMap: <R = T>(this: T[], options?: Nullable<$mapCallback<T, R> | $mapOptions<T, R>>) => R[];
        filteredSet: <R = T>(this: T[], callback?: Nullable<$mapCallback<T, R>>) => Set<R>;
        includesequal: (this: T[], object: any) => boolean;
        includesvisual: (this: T[], object: any) => boolean;
        first: (this: T[]) => T | undefined;
        last: (this: T[]) => T | undefined;
        max: (this: T[]) => T | undefined;
        min: (this: T[]) => T | undefined;
        singular: (this: T[]) => boolean;
        sum: (this: T[]) => number | undefined;
    }
}
