import { TSDateForm } from "./tsdatecomp";
import { int, uint, email, url, UUID, UUIDVersion, isodate, Address, Nullable, StringEncoding, NormativeStringEncoding, Bytes, TSDataLike, TSDictionary } from "./types";
import { TSData } from "./tsdata";
import { TSDate } from "./tsdate";
import { TSCountry } from "./tscountry";
import { TSPhoneNumber } from "./tsphonenumber";
import { TSURLParseOptions } from "./tsurl";
export declare function $defined(o: any): boolean;
export declare function $ok(o: any): boolean;
export declare function $value<T>(o: Nullable<T>, v: T): T;
export declare function $valueornull<T>(o: Nullable<T>): T | null;
export declare function $valueorundefine<T>(o: Nullable<T>): T | undefined;
export declare function $isstring(o: any): boolean;
export declare function $iswhitespace(s: Nullable<string | number>): boolean;
export declare function $isnumber(o: any): boolean;
export declare function $isint(o: any, minimum?: number, maximum?: number): boolean;
export declare function $isunsigned(o: any, maximum?: number): boolean;
export declare function $isbool(o: any): boolean;
export declare function $isobject(o: any): boolean;
export declare function $objectcount(o: any): number;
export declare function $isarray(o: any): boolean;
export declare function $isiterable(o: any): boolean;
export declare function $isdate(o: any): boolean;
export declare function $isemail(o: any): boolean;
export declare function $isurl(o: any, opts?: Nullable<TSURLParseOptions>): boolean;
export declare function $isphonenumber(o: any, country?: Nullable<TSCountry>): boolean;
export declare function $isuuid(o: any, version?: Nullable<UUIDVersion>): boolean;
export declare function $isdataobject(o: any): boolean;
export declare function $isfunction(o: any): boolean;
export declare function $isproperty(obj: any, prop: string): boolean;
export declare function $ismethod(obj: any, meth: Nullable<string | symbol>): boolean;
export declare function $isipv4(obj: any): boolean;
export declare function $isipv6(obj: any): boolean;
export declare function $isipaddress(obj: any): boolean;
export declare function $hasproperties(obj: any, properties: Nullable<string[]>): boolean;
export declare function $intornull(n: Nullable<string | number | bigint>): int | null;
export declare function $int(n: Nullable<string | number | bigint>, defaultValue?: int): int;
export declare function $email(s: Nullable<string>): email | null;
export declare function $phonenumber(s: Nullable<string>, country?: Nullable<TSCountry>): TSPhoneNumber | null;
export declare function $isophone(s: Nullable<string>, country?: Nullable<TSCountry>): string | null;
export declare function $url(s: Nullable<string>, opts?: Nullable<TSURLParseOptions>): url | null;
export declare function $UUID(s: Nullable<string>, version?: Nullable<UUIDVersion>): UUID | null;
export type IsoDateFormat = TSDateForm.ISO8601C | TSDateForm.ISO8601L | TSDateForm.ISO8601;
export declare function $isodate(s: Nullable<Date | TSDate | string>, format?: IsoDateFormat): isodate | null;
export declare function $address(a: Nullable<Address>): Address | null;
export declare function $unsignedornull(n: Nullable<string | number | bigint>): uint | null;
export declare function $unsigned(v: Nullable<string | number | bigint>, defaultValue?: uint): uint;
export declare function $toint(v: Nullable<string | number | bigint>, defaultValue?: int): int;
export declare function $tounsigned(v: Nullable<string | number>, defaultValue?: uint): uint;
export declare function $string(v: any, yesOrNo?: Nullable<boolean>): string;
export declare function $array<T = any>(...values: T[]): T[];
export declare function $strings(...values: Array<Nullable<string[] | string>>): string[];
export declare function $totype<T>(v: any): T | null;
export declare function $capacityForCount(count: number): uint;
export declare function $count<T = any>(a: Nullable<ArrayLike<T> | Set<T>>): number;
export declare function $length(s: Nullable<string | TSDataLike>): number;
export declare function $lse<T>(s: Nullable<string | TSDataLike | ArrayLike<T>>, start?: Nullable<number>, end?: Nullable<number>): [uint, uint, uint, uint];
export declare function $lengthin(s: Nullable<string | Bytes | TSData>, min?: number, max?: number): boolean;
export declare function $jsonobj(v: any): any;
export declare function $keys<T>(o: Nullable<T>): Array<keyof T>;
export interface $partialOptions<T, U> {
    properties?: Array<keyof T | keyof U>;
    filter?: (v: T[keyof T]) => T[keyof T] | U[keyof U] | undefined;
}
export declare function $partial<T, U>(a: Nullable<T>, opts?: $partialOptions<T, U>): [U, number];
export declare function $dict<T = object>(source: Nullable<T>, keys?: Array<keyof T>): TSDictionary;
export declare function $objectMap<T = object>(source: Nullable<T>, callback?: (key: any, value: any) => [string | undefined, any]): Map<string, any>;
export declare function $includesdict(source: Nullable<object>, dict: TSDictionary, keys?: string[]): boolean;
export interface $fusionOptions<T, U> {
    A?: $partialOptions<T, U>;
    B?: $partialOptions<T, U>;
    fusionArrays?: (a: Array<any>, b: Array<any>) => Array<any>;
    fusionObjects?: (a: object, b: object) => object;
}
export declare function $fusion<T, U>(a: Nullable<T>, b: Nullable<U>, opts?: $fusionOptions<T, U>): [Partial<T> & Partial<U>, number];
export declare function $json(v: any, replacer?: (number | string)[] | null, space?: string | number): string;
export declare function $encoding(e: Nullable<StringEncoding>): NormativeStringEncoding;
