"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$lengthin = exports.$lse = exports.$length = exports.$count = exports.$capacityForCount = exports.$totype = exports.$strings = exports.$array = exports.$string = exports.$tounsigned = exports.$toint = exports.$unsigned = exports.$unsignedornull = exports.$address = exports.$isodate = exports.$UUID = exports.$url = exports.$isophone = exports.$phonenumber = exports.$email = exports.$int = exports.$intornull = exports.$hasproperties = exports.$isipaddress = exports.$isipv6 = exports.$isipv4 = exports.$ismethod = exports.$isproperty = exports.$isfunction = exports.$isdataobject = exports.$isuuid = exports.$isphonenumber = exports.$isurl = exports.$isemail = exports.$isdate = exports.$isiterable = exports.$isarray = exports.$objectcount = exports.$isobject = exports.$isbool = exports.$isunsigned = exports.$isint = exports.$isnumber = exports.$iswhitespace = exports.$isstring = exports.$valueorundefine = exports.$valueornull = exports.$value = exports.$ok = exports.$defined = void 0;
exports.__uuidV4Regex = exports.__uuidV1Regex = exports.$encoding = exports.$json = exports.$fusion = exports.$includesdict = exports.$objectMap = exports.$dict = exports.$partial = exports.$keys = exports.$jsonobj = void 0;
const compare_1 = require("./compare");
const string_tables_1 = require("./string_tables");
const tsdatecomp_1 = require("./tsdatecomp");
const tsdefaults_1 = require("./tsdefaults");
const types_1 = require("./types");
const tsdata_1 = require("./tsdata");
const tsdate_1 = require("./tsdate");
const strings_1 = require("./strings");
const number_1 = require("./number");
const tserrors_1 = require("./tserrors");
const tsphonenumber_1 = require("./tsphonenumber");
const tsurl_1 = require("./tsurl");
function $defined(o) { return o !== undefined && typeof o !== 'undefined'; }
exports.$defined = $defined;
function $ok(o) { return o !== null && o !== undefined && typeof o !== 'undefined'; }
exports.$ok = $ok;
function $value(o, v) { return $ok(o) ? o : v; }
exports.$value = $value;
function $valueornull(o) { return $ok(o) ? o : null; }
exports.$valueornull = $valueornull;
function $valueorundefine(o) { return $ok(o) ? o : undefined; }
exports.$valueorundefine = $valueorundefine;
function $isstring(o) { return typeof o === 'string'; }
exports.$isstring = $isstring;
function $iswhitespace(s) { return $isstring(s) ? string_tables_1.FoundationWhiteSpacesStringCodeSet.has(s) : ($ok(s) ? string_tables_1.FoundationWhiteSpacesNumberCodeSet.has(s) : false); }
exports.$iswhitespace = $iswhitespace;
function $isnumber(o) { return typeof o === 'number' && !isNaN(o) && isFinite(o); }
exports.$isnumber = $isnumber;
function $isint(o, minimum = types_1.INT_MIN, maximum = types_1.INT_MAX) { return typeof o === 'number' && Number.isSafeInteger(o) && o >= minimum && o <= maximum; }
exports.$isint = $isint;
function $isunsigned(o, maximum = types_1.UINT_MAX) { return typeof o === 'number' && Number.isSafeInteger(o) && o >= 0 && o <= maximum; }
exports.$isunsigned = $isunsigned;
function $isbool(o) { return typeof o === 'boolean'; }
exports.$isbool = $isbool;
function $isobject(o) { return $ok(o) && typeof o === 'object'; }
exports.$isobject = $isobject;
function $objectcount(o) { return o instanceof Map ? o.size : ($isobject(o) ? $keys(o).length : 0); }
exports.$objectcount = $objectcount;
function $isarray(o) { return Array.isArray(o); }
exports.$isarray = $isarray;
function $isiterable(o) { return $isarray(o) || $ismethod(o, Symbol.iterator); }
exports.$isiterable = $isiterable;
function $isdate(o) { return (o instanceof Date || o instanceof tsdate_1.TSDate || $isstring(o)) && $ok($isodate(o)); }
exports.$isdate = $isdate;
function $isemail(o) { return $isstring(o) && $ok($email(o)); }
exports.$isemail = $isemail;
function $isurl(o, opts) { return (o instanceof tsurl_1.TSURL) || (o instanceof URL && $ok(tsurl_1.TSURL.from(o, opts))) || ($isstring(o) && $ok(tsurl_1.TSURL.url(o, opts))); }
exports.$isurl = $isurl;
function $isphonenumber(o, country) { return o instanceof tsphonenumber_1.TSPhoneNumber || ($isstring(o) && tsphonenumber_1.TSPhoneNumber.validity(o, country) === tsphonenumber_1.PhoneValidity.OK); }
exports.$isphonenumber = $isphonenumber;
function $isuuid(o, version) { return $isstring(o) && $ok($UUID(o, version)); }
exports.$isuuid = $isuuid;
function $isdataobject(o) { return o instanceof tsdata_1.TSData || o instanceof Uint8Array || o instanceof ArrayBuffer; }
exports.$isdataobject = $isdataobject;
function $isfunction(o) { return typeof o === 'function'; }
exports.$isfunction = $isfunction;
function $isproperty(obj, prop) { return prop.length > 0 && $isobject(obj) && (prop in obj); }
exports.$isproperty = $isproperty;
function $ismethod(obj, meth) { return (typeof meth === 'symbol' || $length(meth) > 0) && $ok(obj) && $isfunction(obj[meth]); }
exports.$ismethod = $ismethod;
function $isipv4(obj) { return typeof obj === 'string' && __IPV4Regex.test((0, strings_1.$ftrim)(obj)); }
exports.$isipv4 = $isipv4;
function $isipv6(obj) { return typeof obj === 'string' && __IPV6Regex.test((0, strings_1.$ftrim)(obj)); }
exports.$isipv6 = $isipv6;
function $isipaddress(obj) {
    if (typeof obj !== 'string') {
        return false;
    }
    obj = (0, strings_1.$ftrim)(obj);
    return __IPV4Regex.test(obj) || __IPV6Regex.test(obj);
}
exports.$isipaddress = $isipaddress;
function $hasproperties(obj, properties) {
    if (!$isobject(obj) || !$count(properties)) {
        return false;
    }
    for (let p of properties) {
        if (!p.length || !(p in obj))
            return false;
    }
    return true;
}
exports.$hasproperties = $hasproperties;
function $intornull(n) {
    if (!$ok(n)) {
        return null;
    }
    else if ($isstring(n)) {
        n = parseInt(n, 10);
    }
    else if (typeof n === 'bigint') {
        return n >= types_1.INT_MIN_BIG && n <= types_1.INT_MAX_BIG ? Number(n) : null;
    }
    return $isint(n) ? n : null;
}
exports.$intornull = $intornull;
function $int(n, defaultValue = 0) { return $value($intornull(n), defaultValue); }
exports.$int = $int;
function $email(s) {
    const m = _regexvalidatedstring(__emailRegex, s, types_1.EMAIL_MIN_LENGTH);
    return $ok(m) ? m.toLowerCase() : null;
}
exports.$email = $email;
function $phonenumber(s, country) { return tsphonenumber_1.TSPhoneNumber.fromString(s, country); }
exports.$phonenumber = $phonenumber;
function $isophone(s, country) { var _a; return $valueornull((_a = tsphonenumber_1.TSPhoneNumber.fromString(s, country)) === null || _a === void 0 ? void 0 : _a.toString()); }
exports.$isophone = $isophone;
function $url(s, opts) { var _a; return $valueornull((_a = tsurl_1.TSURL.url(s, opts)) === null || _a === void 0 ? void 0 : _a.href); }
exports.$url = $url;
function $UUID(s, version) { return $isstring(s) ? _regexvalidatedstring(version === 4 ? exports.__uuidV4Regex : exports.__uuidV1Regex, s, types_1.UUID_LENGTH, types_1.UUID_LENGTH) : null; }
exports.$UUID = $UUID;
function $isodate(s, format = tsdatecomp_1.TSDateForm.ISO8601) {
    let cps = null;
    if ($ok(s)) {
        if (s instanceof Date) {
            cps = (0, tsdatecomp_1.$components)(s);
        }
        else if (s instanceof tsdate_1.TSDate) {
            cps = s.toComponents();
        }
        else if ($isstring(s)) {
            cps = (0, tsdatecomp_1.$parsedatetime)((0, strings_1.$ftrim)(s), format);
        }
    }
    return $ok(cps) ? (0, tsdatecomp_1.$components2string)(cps, format) : null;
}
exports.$isodate = $isodate;
function $address(a) {
    if (!$isobject(a)) {
        return null;
    }
    const city = (0, strings_1.$ftrim)(a === null || a === void 0 ? void 0 : a.city);
    const country = (0, tsdefaults_1.$country)(a === null || a === void 0 ? void 0 : a.country);
    if (!$isstring(city) || !$length(city) || !$ok(country)) {
        return null;
    }
    let ret = Object.assign({}, a);
    ret.city = city;
    ret.country = country;
    return ret;
}
exports.$address = $address;
function $unsignedornull(n) {
    if (!$ok(n)) {
        return null;
    }
    else if ($isstring(n)) {
        n = parseInt(n, 10);
    }
    else if (typeof n === 'bigint') {
        return n >= types_1.UINT_MIN_BIG && n <= types_1.UINT_MAX_BIG ? Number(n) : null;
    }
    return $isunsigned(n) ? n : null;
}
exports.$unsignedornull = $unsignedornull;
function $unsigned(v, defaultValue = 0) { return $value($unsignedornull(v), defaultValue); }
exports.$unsigned = $unsigned;
function $toint(v, defaultValue = 0) {
    if (!$ok(v)) {
        return defaultValue;
    }
    else if (typeof v === 'bigint') {
        v = v >= types_1.INT_MIN_BIG && v <= types_1.INT_MAX_BIG ? Number(v) : defaultValue;
    }
    else if ($isstring(v)) {
        v = parseInt(v, 10);
    }
    return isNaN(v) ? defaultValue : Math.max(types_1.INT_MIN, (0, number_1.$icast)(Math.min(v, types_1.INT_MAX)));
}
exports.$toint = $toint;
function $tounsigned(v, defaultValue = 0) {
    if (!$ok(v)) {
        return defaultValue;
    }
    else if (typeof v === 'bigint') {
        v = v >= types_1.UINT_MIN_BIG && v <= types_1.UINT_MAX_BIG ? Number(v) : defaultValue;
    }
    else if ($isstring(v)) {
        v = parseInt(v, 10);
    }
    return isNaN(v) ? defaultValue : Math.max(types_1.UINT_MIN, (0, number_1.$icast)(Math.min(v, types_1.UINT_MAX)));
}
exports.$tounsigned = $tounsigned;
function $string(v, yesOrNo) {
    const t = typeof (v);
    switch (t) {
        case 'string': return v;
        case 'symbol': return _symbol2str(v);
        case 'undefined': return '';
        case 'object': return v !== null ? ($ismethod(v, 'toString') ? v.toString() : `${v}`) : '';
        case 'boolean': return !yesOrNo ? (v ? 'true' : 'false') : (v ? 'YES' : 'NO');
        default: return v.toString();
    }
}
exports.$string = $string;
function $array(...values) { return values; }
exports.$array = $array;
function $strings(...values) {
    switch (values.length) {
        case 0:
            return [];
        case 1:
            return $isstring(values[0]) ? values : ($isarray(values[0]) ? values[0] : []);
        default: {
            const ret = [];
            values.forEach(v => {
                if ($isstring(v)) {
                    ret.push(v);
                }
                else if ($isarray(v)) {
                    v.forEach(s => ret.push(s));
                }
            });
            return ret;
        }
    }
}
exports.$strings = $strings;
function $totype(v) { return $ok(v) ? v : null; }
exports.$totype = $totype;
function $capacityForCount(count) {
    count = count <= 0 ? 0 : Math.ceil(count);
    return (count < 128 ? __capacitiesForCounts[count] : ((count + (count >> 1)) & ~255) + 256);
}
exports.$capacityForCount = $capacityForCount;
function $count(a) { return a instanceof Set ? a.size : ($ok(a) ? a.length : 0); }
exports.$count = $count;
function $length(s) { return s instanceof ArrayBuffer ? s.byteLength : ($ok(s) ? s.length : 0); }
exports.$length = $length;
function $lse(s, start, end) {
    if (!$ok(s)) {
        return [0, 0, 0, 0];
    }
    const len = s instanceof ArrayBuffer ? s.byteLength : s.length;
    start = $tounsigned(start);
    end = Math.min($tounsigned(end, len), len);
    return [len, start, end, Math.max(end - start, 0)];
}
exports.$lse = $lse;
function $lengthin(s, min = 0, max = types_1.INT_MAX) { const l = $length(s); return l >= min && l <= max; }
exports.$lengthin = $lengthin;
function $jsonobj(v) {
    if (!$ok(v)) {
        return v;
    }
    if ($ismethod(v, 'toJSON')) {
        return v.toJSON();
    }
    switch (typeof v) {
        case 'object':
        case 'boolean':
        case 'number':
        case 'bigint':
        case 'string':
            return v;
        default:
            return undefined;
    }
}
exports.$jsonobj = $jsonobj;
function $keys(o) { return $ok(o) ? Object.getOwnPropertyNames(o) : []; }
exports.$keys = $keys;
function $partial(a, opts = {}) {
    let ret = {};
    let n = 0;
    if ($ok(a)) {
        n = _fillObject('partial', ret, a, opts);
    }
    return [ret, n];
}
exports.$partial = $partial;
function $dict(source, keys) {
    const ret = {};
    if ($ok(source)) {
        _fillObject('dict', ret, source, { properties: keys });
    }
    return ret;
}
exports.$dict = $dict;
function $objectMap(source, callback) {
    if (!$ok(callback)) {
        callback = function (k, v) {
            const tk = $string(k);
            return tk.length > 0 ? [tk, v] : [undefined, v];
        };
    }
    const map = new Map();
    if (source instanceof Map) {
        const entries = source.entries();
        for (let [k0, v0] of entries) {
            const [k, v] = callback(k0, v0);
            if ($defined(v) && $defined(v)) {
                map.set(k, v);
            }
        }
    }
    else {
        const keys = $keys(source);
        for (let key of keys) {
            const [k, v] = callback(key, source[key]);
            if ($defined(v) && $defined(v)) {
                map.set(k, v);
            }
        }
    }
    return map;
}
exports.$objectMap = $objectMap;
function $includesdict(source, dict, keys) {
    if ($ok(source)) {
        keys = $ok(keys) ? keys : $keys(dict);
        if (keys.length) {
            const v = source;
            for (let k of keys) {
                if (!(0, compare_1.$equal)(v[k], dict[k])) {
                    return false;
                }
            }
            return true;
        }
    }
    return false;
}
exports.$includesdict = $includesdict;
function $fusion(a, b, opts = {}) {
    if (!$ok(a)) {
        return $ok(b) ? $partial(b, opts.B) : [{}, 0];
    }
    else if (!$ok(b)) {
        return $partial(a, opts.A);
    }
    let [ret, n] = $partial(a, opts.A);
    let fopts = $ok(opts.B) ? Object.assign({}, opts.B) : {};
    if ($ok(opts.fusionArrays)) {
        fopts.fusionArrays = opts.fusionArrays;
    }
    if ($ok(opts.fusionObjects)) {
        fopts.fusionObjects = opts.fusionObjects;
    }
    n += _fillObject('fusion', ret, b, fopts);
    return [ret, n];
}
exports.$fusion = $fusion;
function $json(v, replacer = null, space = 2) { return JSON.stringify(v, replacer, space); }
exports.$json = $json;
function $encoding(e) {
    if ($length(e) === 0 || e === 'utf8') {
        return 'utf8';
    }
    return $value(string_tables_1.FoundationStringEncodingsMap.get(e), 'utf8');
}
exports.$encoding = $encoding;
exports.__uuidV1Regex = /^[A-F\d]{8}-[A-F\d]{4}-[A-F\d]{4}-[A-F\d]{4}-[A-F\d]{12}$/i;
exports.__uuidV4Regex = /^[A-F\d]{8}-[A-F\d]{4}-4[A-F\d]{3}-[89AB][A-F\d]{3}-[A-F\d]{12}$/i;
function _symbol2str(v) {
    const s = v.toString();
    if (s.startsWith('Symbol(') && s.endsWith(')')) {
        return s.slice(7, s.length - 1);
    }
    return $value(Symbol.keyFor(v), '');
}
const __emailRegex = /^(([^<>()\[\]\.,;:\s@\"]+(\.[^<>()\[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()\.,;\s@\"]+\.{0,1})+([^<>()\.,;:\s@\"]{2,}|[\d\.]+))$/;
function _regexvalidatedstring(regex, s, minLength, maxLength) {
    const v = (0, strings_1.$ftrim)(s);
    const min = $value(minLength, 1);
    const max = $value(maxLength, types_1.UINT_MAX);
    if (v.length < min || v.length > max || !regex.test(v)) {
        return null;
    }
    return v;
}
function _fillObject(fn, destination, source, opts = {}) {
    let ret = 0;
    opts = Object.assign({}, opts);
    opts.properties = $ok(opts.properties) ? opts.properties : $keys(source);
    if (opts.properties.length) {
        const fusion_arrays = $isfunction(opts.fusionArrays);
        const fusion_objects = $isfunction(opts.fusionObjects);
        opts.filter = $isfunction(opts.filter) ? opts.filter : (v) => $ok(v) && typeof v !== 'function' ? v : undefined;
        for (let p of opts.properties) {
            if (!$isstring(p)) {
                tserrors_1.TSError.throw(`$${fn}() needs to have valid string properties`, { function: fn, source: source, destination: destination, options: opts });
            }
            const v = opts.filter(source[p]);
            if ($defined(v)) {
                if (fusion_arrays && $isarray(v) && $isarray(destination[p])) {
                    destination[p] = opts.fusionArrays(destination[p], v);
                }
                else if (fusion_objects && $isobject(v) && $isobject(destination[p])) {
                    destination[p] = opts.fusionObjects(destination[p], v);
                }
                else {
                    destination[p] = v;
                }
                ret++;
            }
        }
    }
    return ret;
}
const __IPV6Regex = /^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/;
const __IPV4Regex = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
const __capacitiesForCounts = [
    2, 2, 4, 4, 8, 8, 8, 8,
    16, 16, 16, 16, 16, 16, 16, 16,
    32, 32, 32, 32, 32, 32, 32, 32,
    32, 32, 32, 32, 32, 32, 32, 32,
    64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    256, 256, 256, 256, 256, 256, 256, 256,
    256, 256, 256, 256, 256, 256, 256, 256,
    256, 256, 256, 256, 256, 256, 256, 256
];
//# sourceMappingURL=commons.js.map