import { Nullable, StringDictionary, TSDataLike, TSDictionary } from "./types";
import { DefaultsConfigurationOptions } from "./tsdefaults";
import { TSLeafNode } from "./tsparser";
import { TSURL } from "./tsurl";
export interface $envOptions extends DefaultsConfigurationOptions {
    merge?: Nullable<StringDictionary>;
    reference?: Nullable<StringDictionary>;
}
export declare function $env(source: Nullable<string | TSDataLike>, opts?: Nullable<$envOptions>): StringDictionary | null;
export interface $parsedEnvOptions extends DefaultsConfigurationOptions {
    parser: Nullable<TSDictionary<TSLeafNode>>;
    merge?: Nullable<TSDictionary>;
    reference?: Nullable<TSDictionary>;
    acceptsUnparsed?: Nullable<boolean>;
}
export declare function $parsedenv(source: Nullable<string | TSDataLike>, opts: $parsedEnvOptions): TSDictionary | null;
export type TSArgumentDictionary = TSDictionary<TSArgument | TSLeafNode>;
export interface TSArgument {
    struct: TSLeafNode;
    noDoubleDash?: boolean;
    defaultValue?: any;
    short?: string;
    negative?: string;
    negativeShort?: string;
}
export interface TSArgsOptions {
    errors?: Nullable<string[]>;
    arguments?: Nullable<URL | TSURL | string[]>;
    processName?: Nullable<string>;
    exitError?: Nullable<number>;
}
export declare function $args(definition: TSArgumentDictionary, opts?: Nullable<TSArgsOptions>): [TSDictionary | null, string[]];
export declare function $argCheck(exitStatus: number, errors: Nullable<string[] | TSArgsOptions>, processName?: Nullable<string>): void;
