"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$dictionaryFromMap = exports.$conditionalClearMap = exports.$conditionalClearSet = exports.$mapmap = exports.$setmap = void 0;
const types_1 = require("./types");
const commons_1 = require("./commons");
const compare_1 = require("./compare");
const object_1 = require("./object");
function $setmap(set, mapFunction) {
    const ret = new Set();
    set === null || set === void 0 ? void 0 : set.forEach(e => { const u = mapFunction(e); if ((0, commons_1.$ok)(u)) {
        ret.add(u);
    } });
    return ret;
}
exports.$setmap = $setmap;
function $mapmap(map, mapFunction) {
    const ret = new Map();
    map === null || map === void 0 ? void 0 : map.forEach((v, k) => { const u = mapFunction(k, v); if ((0, commons_1.$ok)(u)) {
        ret.set(k, u);
    } });
    return ret;
}
exports.$mapmap = $mapmap;
function $conditionalClearSet(set, clearFunction) {
    if ((0, commons_1.$ok)(set)) {
        const toBeCleared = [];
        set.forEach(e => { if (clearFunction(e)) {
            toBeCleared.push(e);
        } });
        toBeCleared.forEach(e => set.delete(e));
        return toBeCleared.length;
    }
    return types_1.UINT_MIN;
}
exports.$conditionalClearSet = $conditionalClearSet;
function $conditionalClearMap(map, clearFunction) {
    if ((0, commons_1.$ok)(map)) {
        const toBeCleared = [];
        map.forEach((v, k) => { if (clearFunction(k, v)) {
            toBeCleared.push(k);
        } });
        toBeCleared.forEach(k => map.delete(k));
        return toBeCleared.length;
    }
    return types_1.UINT_MIN;
}
exports.$conditionalClearMap = $conditionalClearMap;
function $dictionaryFromMap(map, mapFunction) {
    const ret = {};
    const fn = (0, commons_1.$ok)(mapFunction) ? mapFunction : _simpleConvert;
    map === null || map === void 0 ? void 0 : map.forEach((v0, k0) => {
        const [k, u] = fn(k0, v0);
        if ((0, commons_1.$ok)(u) && (0, commons_1.$length)(k) > 0) {
            ret[k] = u;
        }
    });
    return ret;
}
exports.$dictionaryFromMap = $dictionaryFromMap;
function _simpleConvert(key, value) { return [(0, commons_1.$string)(key), value]; }
(0, object_1.$declareAccessor)(Set, { element: 'length', getter: function () { return this.size; } });
Set.prototype.compare = function compare(other) { return other instanceof Set && (0, compare_1.$setequal)(this, other) ? types_1.Same : undefined; };
Set.prototype.conditionalClear = function conditionalClear(clearFunction) { return $conditionalClearSet(this, clearFunction); };
Set.prototype.fusionEnumeration = function fusionEnumeration() { return Array.from(this); };
Set.prototype.isEqual = function isEqual(other) { return other instanceof Set && (0, compare_1.$setequal)(this, other); };
Set.prototype.keysArray = function keysArray() { return Array.from(this.values()); };
Set.prototype.map = function map(mapFunction) { return $setmap(this, mapFunction); };
Set.prototype.singular = function singular() { return this.size === 1; };
Set.prototype.toArray = function toArray() { return Array.from(this.values()); };
Set.prototype.valuesArray = function valuesArray() { return Array.from(this.values()); };
Map.prototype.compare = function compare(other) { return other instanceof Map && (0, compare_1.$mapequal)(this, other) ? types_1.Same : undefined; };
Map.prototype.conditionalClear = function conditionalClear(clearFunction) { return $conditionalClearMap(this, clearFunction); };
Map.prototype.dictionary = function dictionary(mapFunction) {
    return $dictionaryFromMap(this, mapFunction);
};
Map.prototype.fusionEnumeration = function fusionEnumeration() {
    const ret = [];
    this.forEach((value, key) => ret.push({ key: key, value: value }));
    return ret;
};
Map.prototype.isEqual = function isEqual(other) { return other instanceof Map && (0, compare_1.$mapequal)(this, other); };
Map.prototype.keysArray = function keysArray() { return Array.from(this.keys()); };
Map.prototype.map = function map(mapFunction) { return $mapmap(this, mapFunction); };
Map.prototype.toArray = function toArray() { return Array.from(this.entries()); };
Map.prototype.valuesArray = function valuesArray() { return Array.from(this.values()); };
//# sourceMappingURL=mapset.js.map