import { TSCountry } from "./tscountry";
import { TSDate } from "./tsdate";
import { $durationDescriptionOptions, TSDateComp, TSDurationComp } from "./tsdatecomp";
import { Locales } from "./tsdefaults";
import { country, int, language, Nullable, uint } from "./types";
export declare function $div(a: number, b: number): number;
export declare function $icast(v: number): number;
export declare function $round(v: number, decimalPlaces?: number): number;
export declare function $fpad2(v: number, failedChar?: string): string;
export declare function $fpad3(v: number, failedChar?: string): string;
export declare function $fpad4(v: number, failedChar?: string): string;
export declare function $fpad(v: number, pad: number, failedChar?: string): string;
export interface $unitOptions {
    unitName?: string;
    pluralUnitName?: string;
    unit?: string;
    minimalUnit?: number;
    maximalUnit?: number;
    decimalPlaces?: number;
    ignoreZeroDecimals?: boolean;
    ignoreMinimalUnitDecimals?: boolean;
}
export declare function $unit(n: Nullable<number>, opts?: Nullable<$unitOptions>): string;
export declare function $bytes(n: Nullable<number>, decimalPlaces?: number, locale?: Nullable<language | country | TSCountry | Locales>): string;
export declare function $octets(n: Nullable<number>, decimalPlaces?: number): string;
export declare function $meters(n: Nullable<number>, decimalPlaces?: number): string;
declare global {
    export interface Number {
        bytes: (this: number, decimalPlaces?: number, locale?: Nullable<language | country | TSCountry | Locales>) => string;
        dateComponents: (this: number) => TSDateComp;
        durationComponents: (this: number) => TSDurationComp;
        fpad: (this: number, pad: number, failedChar?: string) => string;
        fpad2: (this: number, failedChar?: string) => string;
        fpad3: (this: number, failedChar?: string) => string;
        fpad4: (this: number, failedChar?: string) => string;
        hexaValue: (this: number) => number;
        icast: (this: number) => number;
        isNewLine: (this: number) => boolean;
        isWhiteSpace: (this: number) => boolean;
        isStrictWhiteSpace: (this: number) => boolean;
        meters: (this: number, decimalPlaces?: number) => string;
        octets: (this: number, decimalPlaces?: number) => string;
        round: (this: number, decimalPlaces?: number) => number;
        singular: (this: number) => boolean;
        toDate: (this: number) => Date | null;
        toDurationString: (this: number, format?: Nullable<string>) => string;
        toDurationDescription: (this: number, opts?: Nullable<$durationDescriptionOptions>) => string;
        toHex1: (this: number, toLowerCase?: Nullable<boolean>) => string;
        toHex2: (this: number, toLowerCase?: Nullable<boolean>) => string;
        toHex4: (this: number, toLowerCase?: Nullable<boolean>) => string;
        toHex8: (this: number, toLowerCase?: Nullable<boolean>) => string;
        toInt: (this: number, defaultValue?: int) => int;
        toTSDate: (this: number) => TSDate | null;
        toUnsigned: (this: number, defaultValue?: uint) => uint;
        unit: (this: number, opts?: Nullable<$unitOptions>) => string;
    }
}
