export type TSConstructor<T = unknown> = new (...args: any[]) => T;
export interface TSClassElementDeclaration {
    element: string;
    enumerable?: boolean;
    configurable?: boolean;
}
export interface TSClassMethodDeclaration extends TSClassElementDeclaration {
    implementation: Function;
}
export declare function $declareMethod<T>(cls: TSConstructor<T>, decl: TSClassMethodDeclaration): void;
export interface TSClassAccessorDeclaration extends TSClassElementDeclaration {
    getter?: () => any;
    setter?: (v: any) => void;
}
export declare function $declareAccessor<T>(cls: TSConstructor<T>, decl: TSClassAccessorDeclaration): void;
