"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$declareAccessor = exports.$declareMethod = void 0;
function $declareMethod(cls, decl) {
    _assertDeclare(cls, decl, 'method');
    if (!_localOK(decl === null || decl === void 0 ? void 0 : decl.implementation)) {
        throw `Impossible to declare non-implemented method '${decl.element}()' to class '${cls.name}'`;
    }
    if (!(typeof (decl === null || decl === void 0 ? void 0 : decl.implementation) === 'function')) {
        throw `Wrong implementation for method set '${decl === null || decl === void 0 ? void 0 : decl.element}'() to class '${cls.name}'`;
    }
    Object.defineProperty(cls.prototype, decl.element, { value: decl.implementation, enumerable: !!(decl === null || decl === void 0 ? void 0 : decl.enumerable), configurable: !!(decl === null || decl === void 0 ? void 0 : decl.configurable) });
}
exports.$declareMethod = $declareMethod;
function $declareAccessor(cls, decl) {
    _assertDeclare(cls, decl, 'accessor');
    if (!_localOK(decl === null || decl === void 0 ? void 0 : decl.getter) && !_localOK(decl === null || decl === void 0 ? void 0 : decl.setter)) {
        throw `Impossible to declare non-implemented accessor '${decl === null || decl === void 0 ? void 0 : decl.element}' to class '${cls.name}'`;
    }
    if (_localOK(decl === null || decl === void 0 ? void 0 : decl.getter) && typeof (decl === null || decl === void 0 ? void 0 : decl.getter) !== 'function') {
        throw `Wrong implementation for accessor get '${decl === null || decl === void 0 ? void 0 : decl.element}'() to class '${cls.name}'`;
    }
    if (_localOK(decl === null || decl === void 0 ? void 0 : decl.setter) && typeof (decl === null || decl === void 0 ? void 0 : decl.setter) !== 'function') {
        throw `Wrong implementation for accessor set '${decl === null || decl === void 0 ? void 0 : decl.element}'() to class '${cls.name}'`;
    }
    Object.defineProperty(cls.prototype, decl.element, {
        get: (decl === null || decl === void 0 ? void 0 : decl.getter) === null ? undefined : decl === null || decl === void 0 ? void 0 : decl.getter,
        set: (decl === null || decl === void 0 ? void 0 : decl.setter) === null ? undefined : decl === null || decl === void 0 ? void 0 : decl.setter,
        enumerable: !!(decl === null || decl === void 0 ? void 0 : decl.enumerable), configurable: !!(decl === null || decl === void 0 ? void 0 : decl.configurable)
    });
}
exports.$declareAccessor = $declareAccessor;
function _assertDeclare(cls, decl, type) {
    var _a;
    if (!_localOK(cls)) {
        throw `Impossible to declare ${type} ${decl === null || decl === void 0 ? void 0 : decl.element} on undefined class.`;
    }
    if (!_localOK(decl === null || decl === void 0 ? void 0 : decl.element) || ((_a = decl === null || decl === void 0 ? void 0 : decl.element) === null || _a === void 0 ? void 0 : _a.length) === 0) {
        throw `Impossible to declare unknown ${type} on class ${cls.name}.`;
    }
}
function _localOK(v) { return v !== null && v !== undefined && typeof v !== 'undefined'; }
//# sourceMappingURL=object.js.map