"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FoundationHTMLStructureEncoding = exports.FoundationHTMLEncoding = exports.FoundationStringEncodingsMap = exports.FoundationEncodingsAliases = exports.FoundationStrictWhiteSpacesStringCodeSet = exports.FoundationStricWhiteSpacesNumberCodeSet = exports.FoundationNewLineStringCodeSet = exports.FoundationNewLineNumberCodeSet = exports.FoundationWhiteSpacesStringCodeSet = exports.FoundationWhiteSpacesNumberCodeSet = exports.FoundationRightTrimRegex = exports.FoundationLeftTrimRegex = exports.FoundationFindStrictWhitespacesRegex = exports.FoundationFindAllWhitespacesRegex = exports.FoundationASCIIConversion = exports.FoundationWhiteSpaces = exports.FoundationStrictWhiteSpaces = exports.FoundationNewLines = exports.FoundationBinaryWhiteSpaces = exports.FoundationBynaryStrictWhiteSpaces = exports.FoundationBinaryNewLines = exports.FoundationASCIIWhiteSpaces = exports.FoundationASCIIStrictWhiteSpaces = exports.FoundationASCIINewLines = void 0;
exports.FoundationASCIINewLines = "\u000a\u000c\u000d";
exports.FoundationASCIIStrictWhiteSpaces = "\u0009\u000b\u0020";
exports.FoundationASCIIWhiteSpaces = exports.FoundationASCIIStrictWhiteSpaces + exports.FoundationASCIINewLines;
exports.FoundationBinaryNewLines = exports.FoundationASCIINewLines + "\u0085";
exports.FoundationBynaryStrictWhiteSpaces = exports.FoundationASCIIStrictWhiteSpaces + "\u00A0";
exports.FoundationBinaryWhiteSpaces = exports.FoundationBynaryStrictWhiteSpaces + exports.FoundationBinaryNewLines;
exports.FoundationNewLines = exports.FoundationBinaryNewLines + "\u2028\u2029";
exports.FoundationStrictWhiteSpaces = exports.FoundationBynaryStrictWhiteSpaces + "\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u200B\u202F\u205F\u3000\uFEFF";
exports.FoundationWhiteSpaces = exports.FoundationStrictWhiteSpaces + exports.FoundationNewLines;
exports.FoundationASCIIConversion = {
    '¡': '!',
    '¢': 'c',
    '£': 'GBP',
    '¥': 'JPY',
    '¦': '|',
    '©': '(C)',
    '«': '"',
    '®': '(R)',
    '·': '.',
    '»': '"',
    '¿': '?',
    'Æ': 'AE',
    'Ð': 'D',
    '×': 'x',
    'Ø': 'O',
    'Þ': 'TH',
    'ß': 'ss',
    'æ': 'ae',
    'ð': 'd',
    '÷': '/',
    'ø': 'o',
    'þ': 'th',
    'Đ': 'D',
    'đ': 'd',
    'Ħ': 'H',
    'ħ': 'h',
    'ı': 'i',
    'Ł': 'L',
    'ł': 'l',
    'Ŋ': 'N',
    'ŋ': 'n',
    'Œ': 'OE',
    'œ': 'oe',
    'Ŧ': 'T',
    'ŧ': 't',
    'ƀ': 'b',
    'Ɓ': 'B',
    'Ƃ': 'B',
    'ƃ': 'b',
    'Ƅ': 'B',
    'ƅ': 'b',
    'Ɔ': 'O',
    'Ƈ': 'C',
    'ƈ': 'c',
    'Ɖ': 'D',
    'Ɗ': 'D',
    'Ƌ': 'D',
    'ƌ': 'd',
    'ƍ': 'd',
    'Ǝ': 'E',
    'Ə': 'E',
    'Ɛ': 'E',
    'Ƒ': 'F',
    'ƒ': 'f',
    'Ɠ': 'G',
    'Ɣ': 'G',
    'ƕ': 'hv',
    'Ɩ': 'I',
    'Ɨ': 'I',
    'Ƙ': 'K',
    'ƙ': 'k',
    'ƚ': 'i',
    'ƛ': 'l',
    'Ɯ': 'M',
    'Ɲ': 'N',
    'ƞ': 'n',
    'Ɵ': 'O',
    'Ƣ': 'OI',
    'ƣ': 'oi',
    'Ƥ': 'P',
    'ƥ': 'p',
    'Ʀ': 'YR',
    'Ƨ': 'S',
    'ƨ': 's',
    'Ʃ': 'S',
    'ƪ': 's',
    'ƫ': 't',
    'Ƭ': 'T',
    'ƭ': 't',
    'Ʈ': 'T',
    'Ʋ': 'v',
    'Ƴ': 'Y',
    'ƴ': 'y',
    'Ƶ': 'Z',
    'ƶ': 'z',
    'Ʒ': 'Z',
    'Ƹ': 'Z',
    'ƹ': 'z',
    'ƺ': 'z',
    'ƻ': '2',
    'ƿ': 'w',
    'ǃ': '!',
    'ǝ': 'e',
    'Ǥ': 'G',
    'ǥ': 'g',
    'Ǯ': 'Z',
    'ǯ': 'z',
    'Ƕ': 'HV',
    'Ƿ': 'W',
    'Ȝ': 'G',
    'ȝ': 'g',
    'Ƞ': 'N',
    'ȡ': 'd',
    'Ȣ': 'OU',
    'ȣ': 'ou',
    'Ȥ': 'Z',
    'ȥ': 'z',
    'ȴ': 'l',
    'ȵ': 'n',
    'ȶ': 't',
    'ȷ': 'j',
    'ȸ': 'db',
    'ȹ': 'qp',
    'Ⱥ': 'A',
    'Ȼ': 'C',
    'ȼ': 'c',
    'Ƚ': 'L',
    'Ⱦ': 'T',
    'ȿ': 's',
    'ɀ': 'z',
    'Ƀ': 'B',
    'Ʉ': 'U',
    'Ʌ': 'V',
    'Ɇ': 'E',
    'ɇ': 'e',
    'Ɉ': 'J',
    'ɉ': 'j',
    'Ɋ': 'Q',
    'ɋ': 'q',
    'Ɍ': 'R',
    'ɍ': 'r',
    'Ɏ': 'Y',
    'ɏ': 'y',
    'ɐ': 'a',
    'ɑ': 'a',
    'ɒ': 'a',
    'ɓ': 'b',
    'ɔ': 'o',
    'ɕ': 'c',
    'ɖ': 'd',
    'ɘ': 'e',
    'ə': 'e',
    'ɚ': 'e',
    'ɛ': 'e',
    'ɜ': 'e',
    'ɝ': 'e',
    'ɞ': 'e',
    'ɟ': 'j',
    'ɠ': 'g',
    'ɡ': 'g',
    'ɢ': 'G',
    'ɣ': 'g',
    'ɥ': 'h',
    'ɦ': 'h',
    'ɧ': 'h',
    'ɨ': 'i',
    'ɩ': 'i',
    'ɪ': 'I',
    'ɫ': 'l',
    'ɬ': 'l',
    'ɭ': 'l',
    'ɮ': 'lz',
    'ɯ': 'm',
    'ɰ': 'm',
    'ɱ': 'm',
    'ɲ': 'n',
    'ɳ': 'n',
    'ɴ': 'N',
    'ɵ': 'o',
    'ɶ': 'OE',
    'ɷ': 'o',
    'ɹ': 'r',
    'ɺ': 'r',
    'ɻ': 'r',
    'ɼ': 'r',
    'ɽ': 'r',
    'ɾ': 'r',
    'ɿ': 'r',
    'ʀ': 'R',
    'ʁ': 'R',
    'ʂ': 's',
    'ʃ': 's',
    'ʄ': 'j',
    'ʅ': 's',
    'ʆ': 's',
    'ʇ': 't',
    'ʈ': 't',
    'ʉ': 'u',
    'ʋ': 'v',
    'ʌ': 'v',
    'ʍ': 'W',
    'ʎ': 'y',
    'ʏ': 'Y',
    'ʐ': 'z',
    'ʑ': 'z',
    'ʒ': 'z',
    'ʓ': 'z',
    'ʗ': 'C',
    'ʙ': 'B',
    'ʚ': 'e',
    'ʛ': 'G',
    'ʜ': 'H',
    'ʝ': 'j',
    'ʞ': 'k',
    'ʟ': 'L',
    'ʠ': 'q',
    'ʣ': 'dz',
    'ʤ': 'dz',
    'ʥ': 'dz',
    'ʦ': 'ts',
    'ʧ': 'ts',
    'ʨ': 'tc',
    'ʩ': 'fn',
    'ʪ': 'ls',
    'ʫ': 'lz',
    'ʬ': 'ww',
    'ʮ': 'h',
    'ʯ': 'h',
    'Ά': 'A',
    'Έ': 'E',
    'Ή': 'H',
    'Ί': 'I',
    'Ό': 'O',
    'Ύ': 'Y',
    'Ώ': 'O',
    'ΐ': 'i',
    'Α': 'A',
    'Β': 'V',
    'Γ': 'G',
    'Δ': 'D',
    'Ε': 'E',
    'Ζ': 'Z',
    'Η': 'I',
    'Θ': 'TH',
    'Ι': 'I',
    'Κ': 'K',
    'Λ': 'L',
    'Μ': 'M',
    'Ν': 'N',
    'Ξ': 'X',
    'Ο': 'O',
    'Π': 'P',
    'Ρ': 'R',
    'Σ': 'S',
    'Τ': 'T',
    'Υ': 'Y',
    'Φ': 'F',
    'Χ': 'CH',
    'Ψ': 'PS',
    'Ω': 'O',
    'Ϊ': 'I',
    'Ϋ': 'Y',
    'ά': 'a',
    'έ': 'e',
    'ή': 'i',
    'ί': 'i',
    'ΰ': 'y',
    'α': 'a',
    'β': 'v',
    'γ': 'g',
    'δ': 'd',
    'ε': 'e',
    'ζ': 'z',
    'η': 'i',
    'θ': 'th',
    'ι': 'i',
    'κ': 'k',
    'λ': 'l',
    'μ': 'm',
    'ν': 'n',
    'ξ': 'x',
    'ο': 'o',
    'π': 'p',
    'ρ': 'r',
    'ς': 's',
    'σ': 's',
    'τ': 't',
    'υ': 'y',
    'φ': 'f',
    'χ': 'ch',
    'ψ': 'ps',
    'ω': 'o',
    'ϊ': 'i',
    'ϋ': 'y',
    'ό': 'o',
    'ύ': 'y',
    'ώ': 'o',
    'ϐ': 'v',
    'ϑ': 'th',
    'ϒ': 'Y',
    'ϓ': 'Y',
    'ϔ': 'Y',
    'ϕ': 'f',
    'ϱ': 'r',
    'ϲ': 's',
    'ϴ': 'TH',
    'ϵ': 'e',
    '϶': 'e',
    'Ϲ': 'S',
    'ϼ': 'r',
    'Ͻ': 'S',
    'Ͼ': 'S',
    'Ͽ': 'S',
    '٠': '0',
    '١': '1',
    '٢': '2',
    '٣': '3',
    '٤': '4',
    '٥': '5',
    '٦': '6',
    '٧': '7',
    '٨': '8',
    '٩': '9',
    '٪': '%',
    '۰': '0',
    '۱': '1',
    '۲': '2',
    '۳': '3',
    '۴': '4',
    '۵': '5',
    '۶': '6',
    '۷': '7',
    '۸': '8',
    '۹': '9',
    'ᴀ': 'A',
    'ᴁ': 'AE',
    'ᴂ': 'ae',
    'ᴃ': 'B',
    'ᴄ': 'C',
    'ᴅ': 'D',
    'ᴆ': 'D',
    'ᴇ': 'E',
    'ᴈ': 'e',
    'ᴉ': 'i',
    'ᴊ': 'J',
    'ᴋ': 'K',
    'ᴌ': 'L',
    'ᴍ': 'M',
    'ᴎ': 'N',
    'ᴏ': 'O',
    'ᴐ': 'O',
    'ᴑ': 'o',
    'ᴒ': 'o',
    'ᴓ': 'o',
    'ᴔ': 'oe',
    'ᴕ': 'OU',
    'ᴖ': 'o',
    'ᴗ': 'o',
    'ᴘ': 'P',
    'ᴙ': 'R',
    'ᴚ': 'R',
    'ᴛ': 'T',
    'ᴜ': 'U',
    'ᴝ': 'u',
    'ᴞ': 'u',
    'ᴟ': 'm',
    'ᴠ': 'V',
    'ᴡ': 'W',
    'ᴢ': 'Z',
    'ᴣ': 'Z',
    'ᵫ': 'ue',
    'ᵬ': 'b',
    'ᵭ': 'd',
    'ᵮ': 'f',
    'ᵯ': 'm',
    'ᵰ': 'n',
    'ᵱ': 'p',
    'ᵲ': 'r',
    'ᵳ': 'r',
    'ᵴ': 's',
    'ᵵ': 't',
    'ᵶ': 'z',
    'ᵷ': 'g',
    'ᵹ': 'g',
    'ᵺ': 'th',
    'ᵻ': 'I',
    'ᵼ': 'i',
    'ᵽ': 'p',
    'ᵾ': 'U',
    'ᶀ': 'b',
    'ᶁ': 'd',
    'ᶂ': 'f',
    'ᶃ': 'g',
    'ᶄ': 'k',
    'ᶅ': 'l',
    'ᶆ': 'm',
    'ᶇ': 'n',
    'ᶈ': 'p',
    'ᶉ': 'r',
    'ᶊ': 's',
    'ᶋ': 's',
    'ᶌ': 'v',
    'ᶍ': 'x',
    'ᶎ': 'z',
    'ᶏ': 'a',
    'ᶐ': 'a',
    'ᶑ': 'd',
    'ᶒ': 'e',
    'ᶓ': 'e',
    'ᶔ': 'e',
    'ᶕ': 'e',
    'ᶖ': 'i',
    'ᶗ': 'o',
    'ᶘ': 's',
    'ᶙ': 'u',
    'ᶚ': 'z',
    'ẜ': 's',
    'ẝ': 's',
    'ẞ': 'SS',
    'ẟ': 'd',
    'Ỻ': 'LL',
    'ỻ': 'll',
    'Ỽ': 'V',
    'ỽ': 'v',
    'Ỿ': 'Y',
    'ỿ': 'y',
    'ἀ': 'a',
    'ἁ': 'a',
    'ἂ': 'a',
    'ἃ': 'a',
    'ἄ': 'a',
    'ἅ': 'a',
    'ἆ': 'a',
    'ἇ': 'a',
    'Ἀ': 'A',
    'Ἁ': 'A',
    'Ἂ': 'A',
    'Ἃ': 'A',
    'Ἄ': 'A',
    'Ἅ': 'A',
    'Ἆ': 'A',
    'Ἇ': 'A',
    'ἐ': 'e',
    'ἑ': 'e',
    'ἒ': 'e',
    'ἓ': 'e',
    'ἔ': 'e',
    'ἕ': 'e',
    'Ἐ': 'E',
    'Ἑ': 'E',
    'Ἒ': 'E',
    'Ἓ': 'E',
    'Ἔ': 'E',
    'Ἕ': 'E',
    'ἠ': 'i',
    'ἡ': 'i',
    'ἢ': 'i',
    'ἣ': 'i',
    'ἤ': 'i',
    'ἥ': 'i',
    'ἦ': 'i',
    'ἧ': 'i',
    'Ἠ': 'I',
    'Ἡ': 'I',
    'Ἢ': 'I',
    'Ἣ': 'I',
    'Ἤ': 'I',
    'Ἥ': 'I',
    'Ἦ': 'I',
    'Ἧ': 'I',
    'ἰ': 'i',
    'ἱ': 'i',
    'ἲ': 'i',
    'ἳ': 'i',
    'ἴ': 'i',
    'ἵ': 'i',
    'ἶ': 'i',
    'ἷ': 'i',
    'Ἰ': 'I',
    'Ἱ': 'I',
    'Ἲ': 'I',
    'Ἳ': 'I',
    'Ἴ': 'I',
    'Ἵ': 'I',
    'Ἶ': 'I',
    'Ἷ': 'I',
    'ὀ': 'o',
    'ὁ': 'o',
    'ὂ': 'o',
    'ὃ': 'o',
    'ὄ': 'o',
    'ὅ': 'o',
    'Ὀ': 'O',
    'Ὁ': 'O',
    'Ὂ': 'O',
    'Ὃ': 'O',
    'Ὄ': 'O',
    'Ὅ': 'O',
    'ὐ': 'y',
    'ὑ': 'y',
    'ὒ': 'y',
    'ὓ': 'y',
    'ὔ': 'y',
    'ὕ': 'y',
    'ὖ': 'y',
    'ὗ': 'y',
    'Ὑ': 'Y',
    'Ὓ': 'Y',
    'Ὕ': 'Y',
    'Ὗ': 'Y',
    'ὠ': 'o',
    'ὡ': 'o',
    'ὢ': 'o',
    'ὣ': 'o',
    'ὤ': 'o',
    'ὥ': 'o',
    'ὦ': 'o',
    'ὧ': 'o',
    'Ὠ': 'O',
    'Ὡ': 'O',
    'Ὢ': 'O',
    'Ὣ': 'O',
    'Ὤ': 'O',
    'Ὥ': 'O',
    'Ὦ': 'O',
    'Ὧ': 'O',
    'ὰ': 'a',
    'ά': 'a',
    'ὲ': 'e',
    'έ': 'e',
    'ὴ': 'i',
    'ή': 'i',
    'ὶ': 'i',
    'ί': 'i',
    'ὸ': 'o',
    'ό': 'o',
    'ὺ': 'y',
    'ύ': 'y',
    'ὼ': 'o',
    'ώ': 'o',
    'ᾀ': 'a',
    'ᾁ': 'a',
    'ᾂ': 'a',
    'ᾃ': 'a',
    'ᾄ': 'a',
    'ᾅ': 'a',
    'ᾆ': 'a',
    'ᾇ': 'a',
    'ᾈ': 'A',
    'ᾉ': 'A',
    'ᾊ': 'A',
    'ᾋ': 'A',
    'ᾌ': 'A',
    'ᾍ': 'A',
    'ᾎ': 'A',
    'ᾏ': 'A',
    'ᾐ': 'i',
    'ᾑ': 'i',
    'ᾒ': 'i',
    'ᾓ': 'i',
    'ᾔ': 'i',
    'ᾕ': 'i',
    'ᾖ': 'i',
    'ᾗ': 'i',
    'ᾘ': 'I',
    'ᾙ': 'I',
    'ᾚ': 'I',
    'ᾛ': 'I',
    'ᾜ': 'I',
    'ᾝ': 'I',
    'ᾞ': 'I',
    'ᾟ': 'I',
    'ᾠ': 'o',
    'ᾡ': 'o',
    'ᾢ': 'o',
    'ᾣ': 'o',
    'ᾤ': 'o',
    'ᾥ': 'o',
    'ᾦ': 'o',
    'ᾧ': 'o',
    'ᾨ': 'O',
    'ᾩ': 'O',
    'ᾪ': 'O',
    'ᾫ': 'O',
    'ᾬ': 'O',
    'ᾭ': 'O',
    'ᾮ': 'O',
    'ᾯ': 'O',
    'ᾰ': 'a',
    'ᾱ': 'a',
    'ᾲ': 'a',
    'ᾳ': 'a',
    'ᾴ': 'a',
    'ᾶ': 'a',
    'ᾷ': 'a',
    'Ᾰ': 'A',
    'Ᾱ': 'A',
    'Ὰ': 'A',
    'Ά': 'A',
    'ᾼ': 'A',
    'ῂ': 'i',
    'ῃ': 'i',
    'ῄ': 'i',
    'ῆ': 'i',
    'ῇ': 'i',
    'Ὲ': 'E',
    'Έ': 'E',
    'Ὴ': 'I',
    'Ή': 'I',
    'ῌ': 'I',
    'ῐ': 'i',
    'ῑ': 'i',
    'ῒ': 'i',
    'ΐ': 'i',
    'ῖ': 'i',
    'ῗ': 'i',
    'Ῐ': 'I',
    'Ῑ': 'I',
    'Ὶ': 'I',
    'Ί': 'I',
    'ῠ': 'y',
    'ῡ': 'y',
    'ῢ': 'y',
    'ΰ': 'y',
    'ῤ': 'r',
    'ῥ': 'r',
    'ῦ': 'y',
    'ῧ': 'y',
    'Ῠ': 'Y',
    'Ῡ': 'Y',
    'Ὺ': 'Y',
    'Ύ': 'Y',
    'Ῥ': 'R',
    'ῲ': 'o',
    'ῳ': 'o',
    'ῴ': 'o',
    'ῶ': 'o',
    'ῷ': 'o',
    'Ὸ': 'O',
    'Ό': 'O',
    'Ὼ': 'O',
    'Ώ': 'O',
    'ῼ': 'O',
    '‐': '-',
    '‑': '-',
    '‒': '-',
    '–': '-',
    '—': '-',
    '―': '-',
    '‘': "'",
    '’': "'",
    '‚': "'",
    '‛': "'",
    '“': '"',
    '”': '"',
    '„': '"',
    '‟': '"',
    '•': '.',
    '‧': '.',
    '′': "'",
    '‵': '`',
    '‹': '<',
    '›': '>',
    '‽': '!?',
    '⁂': '***',
    '⁃': '-',
    '⁄': '/',
    '⁅': '[',
    '⁆': ']',
    '⁎': '*',
    '⁏': ';',
    '⁑': '**',
    '⁒': '%',
    '⁓': '~',
    '⁕': '*',
    '₣': 'FRF',
    '€': 'EUR',
    '℗': '(P)',
    '℘': 'P',
    '℞': 'R',
    '℟': 'R',
    '℮': 'e',
    'Ⅎ': 'F',
    '℺': 'Q',
    '⅁': 'G',
    '⅂': 'L',
    '⅃': 'L',
    '⅄': 'Y',
    '⅋': '&',
    '⅍': 'A/S',
    'ⅎ': 'F',
    '∂': 'd',
    '−': '-',
    '∕': '/',
    '∖': '\\',
    '∗': '*',
    '∙': '.',
    '∼': '~',
    '≤': '<=',
    '≥': '>=',
    '⋜': '=<',
    '⋝': '=>',
    '⋅': '.',
    '⋯': '...',
    '⌗': '#',
    '⌸': '=',
    '⌹': '/',
    '⌿': '/',
    '⍀': '\\',
    '⍁': '/',
    '⍂': '\\',
    '⍃': '<',
    '⍄': '>',
    '⍘': "'",
    '⍠': ':',
    '⍪': ',',
    '⍮': ';',
    '⍯': '!=',
    '⍰': '?',
    '⍳': 'i',
    '⍴': 'r',
    '⍵': 'o',
    '⍶': 'a',
    '⍸': 'i',
    '⍹': 'o',
    '⍺': 'a',
    '⓫': '11',
    '⓬': '12',
    '⓭': '13',
    '⓮': '14',
    '⓯': '15',
    '⓰': '16',
    '⓱': '17',
    '⓲': '18',
    '⓳': '19',
    '⓴': '20',
    '⓵': '1',
    '⓶': '2',
    '⓷': '3',
    '⓸': '4',
    '⓹': '5',
    '⓺': '6',
    '⓻': '7',
    '⓼': '8',
    '⓽': '9',
    '⓾': '10',
    '⓿': '0',
    '☹': ':(',
    '☺': ':)',
    '☻': ':)',
    '❓': '?',
    '❔': '?',
    '❕': '!',
    '❗': '!',
    '❘': '|',
    '❙': '|',
    '❚': '|',
    '❛': "'",
    '❜': "'",
    '❝': '"',
    '❞': '"',
    '❨': '(',
    '❩': ')',
    '❪': '(',
    '❫': ')',
    '❲': '[',
    '❳': ']',
    '❴': '{',
    '❵': '}',
    '❶': '1',
    '❷': '2',
    '❸': '3',
    '❹': '4',
    '❺': '5',
    '❻': '6',
    '❼': '7',
    '❽': '8',
    '❾': '9',
    '❿': '10',
    '➀': '1',
    '➁': '2',
    '➂': '3',
    '➃': '4',
    '➄': '5',
    '➅': '6',
    '➆': '7',
    '➇': '8',
    '➈': '9',
    '➉': '10',
    '➊': '1',
    '➋': '2',
    '➌': '3',
    '➍': '4',
    '➎': '5',
    '➏': '6',
    '➐': '7',
    '➑': '8',
    '➒': '9',
    '➓': '10',
    '➕': '+',
    '➖': '-',
    '➗': '/',
    '⟊': '|',
    '⟋': '/',
    '⟍': '\\',
    '⟦': '[',
    '⟧': ']',
    '⟬': '[',
    '⟭': ']',
    '⟮': '(',
    '⟯': ')',
    '⦃': '{',
    '⦄': '}',
    '⦅': '(',
    '⦆': ')',
    '⦇': '(',
    '⦈': ')',
    '⦋': '[',
    '⦌': ']',
    '⦍': '[',
    '⦎': ']',
    '⦏': '[',
    '⦐': ']',
    '⦗': '[',
    '⦘': ']',
    '⧵': '\\',
    '⧶': '/',
    '⧷': '\\',
    '⧸': '/',
    '⧹': '\\',
    '⩽': '<=',
    '⩾': '>=',
    'Ⱡ': 'L',
    'ⱡ': 'l',
    'Ɫ': 'L',
    'Ᵽ': 'P',
    'Ɽ': 'R',
    'ⱥ': 'a',
    'ⱦ': 't',
    'Ⱨ': 'H',
    'ⱨ': 'h',
    'Ⱪ': 'K',
    'ⱪ': 'k',
    'Ⱬ': 'Z',
    'ⱬ': 'z',
    'Ɑ': 'A',
    'Ɱ': 'M',
    'Ɐ': 'A',
    'Ɒ': 'A',
    'ⱱ': 'v',
    'Ⱳ': 'W',
    'ⱳ': 'w',
    'ⱴ': 'v',
    'Ⱶ': 'H',
    'ⱶ': 'h',
    'ⱷ': 'f',
    'ⱸ': 'e',
    'ⱹ': 'r',
    'ⱺ': 'o',
    'ⱻ': 'E',
    'ⱼ': 'j',
    'Ȿ': 'S',
    'Ɀ': 'Z',
    '・': '.',
    'ー': '-',
    'Ꜧ': 'H',
    'ꜧ': 'h',
    'Ꜩ': 'TZ',
    'ꜩ': 'tz',
    'ꜰ': 'F',
    'ꜱ': 'S',
    'Ꜳ': 'AA',
    'ꜳ': 'aa',
    'Ꜵ': 'AO',
    'ꜵ': 'ao',
    'Ꜷ': 'AU',
    'ꜷ': 'au',
    'Ꜹ': 'AV',
    'ꜹ': 'av',
    'Ꜻ': 'AV',
    'ꜻ': 'av',
    'Ꜽ': 'AY',
    'ꜽ': 'ay',
    'Ꜿ': 'C',
    'ꜿ': 'c',
    'Ꝁ': 'K',
    'ꝁ': 'k',
    'Ꝃ': 'K',
    'ꝃ': 'k',
    'Ꝅ': 'K',
    'ꝅ': 'k',
    'Ꝇ': 'L',
    'ꝇ': 'l',
    'Ꝉ': 'L',
    'ꝉ': 'l',
    'Ꝋ': 'O',
    'ꝋ': 'o',
    'Ꝍ': 'O',
    'ꝍ': 'o',
    'Ꝏ': 'OO',
    'ꝏ': 'oo',
    'Ꝑ': 'P',
    'ꝑ': 'p',
    'Ꝓ': 'P',
    'ꝓ': 'p',
    'Ꝕ': 'P',
    'ꝕ': 'p',
    'Ꝗ': 'Q',
    'ꝗ': 'q',
    'Ꝙ': 'Q',
    'ꝙ': 'q',
    'Ꝛ': 'R',
    'ꝛ': 'r',
    'Ꝟ': 'V',
    'ꝟ': 'v',
    'Ꝡ': 'VY',
    'ꝡ': 'vy',
    'Ꝣ': 'Z',
    'ꝣ': 'z',
    'Ꝥ': 'TH',
    'ꝥ': 'th',
    'Ꝧ': 'TH',
    'ꝧ': 'th',
    'ꝱ': 'd',
    'ꝲ': 'l',
    'ꝳ': 'm',
    'ꝴ': 'n',
    'ꝵ': 'r',
    'ꝶ': 'R',
    'ꝷ': 'f',
    'Ꝺ': 'D',
    'ꝺ': 'd',
    'Ꝼ': 'F',
    'ꝼ': 'f',
    'Ᵹ': 'G',
    'Ꝿ': 'G',
    'ꝿ': 'g',
    'Ꞁ': 'L',
    'ꞁ': 'l',
    'Ꞃ': 'R',
    'ꞃ': 'r',
    'Ꞅ': 'S',
    'ꞅ': 's',
    'Ꞇ': 'T',
    'ꞇ': 't',
    'Ɥ': 'H',
    'ꞎ': 'l',
    'Ꞑ': 'N',
    'ꞑ': 'n',
    'Ꞓ': 'C',
    'ꞓ': 'c',
    'Ꞡ': 'G',
    'ꞡ': 'g',
    'Ꞣ': 'K',
    'ꞣ': 'k',
    'Ꞥ': 'N',
    'ꞥ': 'n',
    'Ꞧ': 'R',
    'ꞧ': 'r',
    'Ꞩ': 'S',
    'ꞩ': 's',
    'Ɦ': 'H',
    'Ɪ': 'I',
    'ꞯ': 'Q',
    'ꞵ': 'b',
    'ꟺ': 'M',
    'ꟻ': 'F',
    'ꟼ': 'P',
    'ꟽ': 'M',
    '﹘': '-',
    '﹝': '[',
    '﹞': ']',
    '｟': '(',
    '｠': ')',
    '𝚤': 'i',
    '𝚥': 'j',
    '𝚨': 'A',
    '𝚩': 'V',
    '𝚪': 'G',
    '𝚫': 'D',
    '𝚬': 'E',
    '𝚭': 'Z',
    '𝚮': 'I',
    '𝚯': 'TH',
    '𝚰': 'I',
    '𝚱': 'K',
    '𝚲': 'L',
    '𝚳': 'M',
    '𝚴': 'N',
    '𝚵': 'X',
    '𝚶': 'O',
    '𝚷': 'P',
    '𝚸': 'R',
    '𝚹': 'TH',
    '𝚺': 'S',
    '𝚻': 'T',
    '𝚼': 'Y',
    '𝚽': 'F',
    '𝚾': 'CH',
    '𝚿': 'PS',
    '𝛀': 'O',
    '𝛂': 'a',
    '𝛃': 'v',
    '𝛄': 'g',
    '𝛅': 'd',
    '𝛆': 'e',
    '𝛇': 'z',
    '𝛈': 'i',
    '𝛉': 'th',
    '𝛊': 'i',
    '𝛋': 'k',
    '𝛌': 'l',
    '𝛍': 'm',
    '𝛎': 'n',
    '𝛏': 'x',
    '𝛐': 'o',
    '𝛑': 'p',
    '𝛒': 'r',
    '𝛓': 's',
    '𝛔': 's',
    '𝛕': 't',
    '𝛖': 'y',
    '𝛗': 'f',
    '𝛘': 'ch',
    '𝛙': 'ps',
    '𝛚': 'o',
    '𝛜': 'e',
    '𝛝': 'th',
    '𝛟': 'f',
    '𝛠': 'r',
    '𝛢': 'A',
    '𝛣': 'V',
    '𝛤': 'G',
    '𝛥': 'D',
    '𝛦': 'E',
    '𝛧': 'Z',
    '𝛨': 'I',
    '𝛩': 'TH',
    '𝛪': 'I',
    '𝛫': 'K',
    '𝛬': 'L',
    '𝛭': 'M',
    '𝛮': 'N',
    '𝛯': 'X',
    '𝛰': 'O',
    '𝛱': 'P',
    '𝛲': 'R',
    '𝛳': 'TH',
    '𝛴': 'S',
    '𝛵': 'T',
    '𝛶': 'Y',
    '𝛷': 'F',
    '𝛸': 'CH',
    '𝛹': 'PS',
    '𝛺': 'O',
    '𝛼': 'a',
    '𝛽': 'v',
    '𝛾': 'g',
    '𝛿': 'd',
    '𝜀': 'e',
    '𝜁': 'z',
    '𝜂': 'i',
    '𝜃': 'th',
    '𝜄': 'i',
    '𝜅': 'k',
    '𝜆': 'l',
    '𝜇': 'm',
    '𝜈': 'n',
    '𝜉': 'x',
    '𝜊': 'o',
    '𝜋': 'p',
    '𝜌': 'r',
    '𝜍': 's',
    '𝜎': 's',
    '𝜏': 't',
    '𝜐': 'y',
    '𝜑': 'f',
    '𝜒': 'ch',
    '𝜓': 'ps',
    '𝜔': 'o',
    '𝜖': 'e',
    '𝜗': 'th',
    '𝜙': 'f',
    '𝜚': 'r',
    '𝜜': 'A',
    '𝜝': 'V',
    '𝜞': 'G',
    '𝜟': 'D',
    '𝜠': 'E',
    '𝜡': 'Z',
    '𝜢': 'I',
    '𝜣': 'TH',
    '𝜤': 'I',
    '𝜥': 'K',
    '𝜦': 'L',
    '𝜧': 'M',
    '𝜨': 'N',
    '𝜩': 'X',
    '𝜪': 'O',
    '𝜫': 'P',
    '𝜬': 'R',
    '𝜭': 'TH',
    '𝜮': 'S',
    '𝜯': 'T',
    '𝜰': 'Y',
    '𝜱': 'F',
    '𝜲': 'CH',
    '𝜳': 'PS',
    '𝜴': 'O',
    '𝜶': 'a',
    '𝜷': 'v',
    '𝜸': 'g',
    '𝜹': 'd',
    '𝜺': 'e',
    '𝜻': 'z',
    '𝜼': 'i',
    '𝜽': 'th',
    '𝜾': 'i',
    '𝜿': 'k',
    '𝝀': 'l',
    '𝝁': 'm',
    '𝝂': 'n',
    '𝝃': 'x',
    '𝝄': 'o',
    '𝝅': 'p',
    '𝝆': 'r',
    '𝝇': 's',
    '𝝈': 's',
    '𝝉': 't',
    '𝝊': 'y',
    '𝝋': 'f',
    '𝝌': 'ch',
    '𝝍': 'ps',
    '𝝎': 'o',
    '𝝐': 'e',
    '𝝑': 'th',
    '𝝓': 'f',
    '𝝔': 'r',
    '𝝖': 'A',
    '𝝗': 'V',
    '𝝘': 'G',
    '𝝙': 'D',
    '𝝚': 'E',
    '𝝛': 'Z',
    '𝝜': 'I',
    '𝝝': 'TH',
    '𝝞': 'I',
    '𝝟': 'K',
    '𝝠': 'L',
    '𝝡': 'M',
    '𝝢': 'N',
    '𝝣': 'X',
    '𝝤': 'O',
    '𝝥': 'P',
    '𝝦': 'R',
    '𝝧': 'TH',
    '𝝨': 'S',
    '𝝩': 'T',
    '𝝪': 'Y',
    '𝝫': 'F',
    '𝝬': 'CH',
    '𝝭': 'PS',
    '𝝮': 'O',
    '𝝰': 'a',
    '𝝱': 'v',
    '𝝲': 'g',
    '𝝳': 'd',
    '𝝴': 'e',
    '𝝵': 'z',
    '𝝶': 'i',
    '𝝷': 'th',
    '𝝸': 'i',
    '𝝹': 'k',
    '𝝺': 'l',
    '𝝻': 'm',
    '𝝼': 'n',
    '𝝽': 'x',
    '𝝾': 'o',
    '𝝿': 'p',
    '𝞀': 'r',
    '𝞁': 's',
    '𝞂': 's',
    '𝞃': 't',
    '𝞄': 'y',
    '𝞅': 'f',
    '𝞆': 'ch',
    '𝞇': 'ps',
    '𝞈': 'o',
    '𝞊': 'e',
    '𝞋': 'th',
    '𝞍': 'f',
    '𝞎': 'r',
    '𝞐': 'A',
    '𝞑': 'V',
    '𝞒': 'G',
    '𝞓': 'D',
    '𝞔': 'E',
    '𝞕': 'Z',
    '𝞖': 'I',
    '𝞗': 'TH',
    '𝞘': 'I',
    '𝞙': 'K',
    '𝞚': 'L',
    '𝞛': 'M',
    '𝞜': 'N',
    '𝞝': 'X',
    '𝞞': 'O',
    '𝞟': 'P',
    '𝞠': 'R',
    '𝞡': 'TH',
    '𝞢': 'S',
    '𝞣': 'T',
    '𝞤': 'Y',
    '𝞥': 'F',
    '𝞦': 'CH',
    '𝞧': 'PS',
    '𝞨': 'O',
    '𝞪': 'a',
    '𝞫': 'v',
    '𝞬': 'g',
    '𝞭': 'd',
    '𝞮': 'e',
    '𝞯': 'z',
    '𝞰': 'i',
    '𝞱': 'th',
    '𝞲': 'i',
    '𝞳': 'k',
    '𝞴': 'l',
    '𝞵': 'm',
    '𝞶': 'n',
    '𝞷': 'x',
    '𝞸': 'o',
    '𝞹': 'p',
    '𝞺': 'r',
    '𝞻': 's',
    '𝞼': 's',
    '𝞽': 't',
    '𝞾': 'y',
    '𝞿': 'f',
    '𝟀': 'ch',
    '𝟁': 'ps',
    '𝟂': 'o',
    '𝟄': 'e',
    '𝟅': 'th',
    '𝟇': 'f',
    '𝟈': 'r',
    '🄋': '0',
    '🄌': '0',
    '🅏': 'WC',
    '🅐': 'A',
    '🅑': 'B',
    '🅒': 'C',
    '🅓': 'D',
    '🅔': 'E',
    '🅕': 'F',
    '🅖': 'G',
    '🅗': 'H',
    '🅘': 'I',
    '🅙': 'J',
    '🅚': 'K',
    '🅛': 'L',
    '🅜': 'M',
    '🅝': 'N',
    '🅞': 'O',
    '🅟': 'P',
    '🅠': 'Q',
    '🅡': 'R',
    '🅢': 'S',
    '🅣': 'T',
    '🅤': 'U',
    '🅥': 'V',
    '🅦': 'W',
    '🅧': 'X',
    '🅨': 'Y',
    '🅩': 'Z',
    '🅰': 'A',
    '🅱': 'B',
    '🅲': 'C',
    '🅳': 'D',
    '🅴': 'E',
    '🅵': 'F',
    '🅶': 'G',
    '🅷': 'H',
    '🅸': 'I',
    '🅹': 'J',
    '🅺': 'K',
    '🅻': 'L',
    '🅼': 'M',
    '🅽': 'N',
    '🅾': 'O',
    '🅿': 'P',
    '🆀': 'Q',
    '🆁': 'R',
    '🆂': 'S',
    '🆃': 'T',
    '🆄': 'U',
    '🆅': 'V',
    '🆆': 'W',
    '🆇': 'X',
    '🆈': 'Y',
    '🆉': 'Z',
    '🆎': 'AB',
    '🆏': 'WC',
    '🆑': 'CL',
    '🆒': 'COOL',
    '🆓': 'FREE',
    '🆔': 'ID',
    '🆕': 'NEW',
    '🆖': 'NG',
    '🆗': 'OK',
    '🆘': 'SOS',
    '🆙': 'UP!',
    '🆚': 'VS',
    "😠": ">:(",
    "😊": ":\")",
    "💔": "<\\3",
    "😕": ":/",
    "😢": ":,(",
    "😦": ":(",
    "❤️": "<3",
    "👿": "]:(",
    "😇": "0:)",
    "😂": ":,)",
    "😗": ":*",
    "😆": "x)",
    "👨": ":3",
    "😐": ":|",
    "😶": ":-",
    "😮": ":o",
    "😡": ":@",
    "😄": ":D",
    "😃": ":)",
    "😈": "]:)",
    "😭": ":,'(",
    "😛": ":p",
    "😝": "xP",
    "😜": ";p",
    "😎": "8)",
    "😓": ",:(",
    "😅": ",:)",
    "😒": ":$",
    "😉": ";)"
};
_addWhiteSpaces();
exports.FoundationFindAllWhitespacesRegex = new RegExp(`[${exports.FoundationWhiteSpaces}]+`, 'g');
exports.FoundationFindStrictWhitespacesRegex = new RegExp(`[${exports.FoundationStrictWhiteSpaces}]+`, 'g');
exports.FoundationLeftTrimRegex = new RegExp(`^[${exports.FoundationWhiteSpaces}]+`);
exports.FoundationRightTrimRegex = new RegExp(`[${exports.FoundationWhiteSpaces}]+$`);
exports.FoundationWhiteSpacesNumberCodeSet = _whiteSpacesAsNumberSet(exports.FoundationWhiteSpaces);
exports.FoundationWhiteSpacesStringCodeSet = _whiteSpaceAsStringSet(exports.FoundationWhiteSpaces);
exports.FoundationNewLineNumberCodeSet = _whiteSpacesAsNumberSet(exports.FoundationNewLines);
exports.FoundationNewLineStringCodeSet = _whiteSpaceAsStringSet(exports.FoundationNewLines);
exports.FoundationStricWhiteSpacesNumberCodeSet = _whiteSpacesAsNumberSet(exports.FoundationStrictWhiteSpaces);
exports.FoundationStrictWhiteSpacesStringCodeSet = _whiteSpaceAsStringSet(exports.FoundationStrictWhiteSpaces);
function _addWhiteSpaces() {
    const len = exports.FoundationWhiteSpaces.length;
    for (let i = 0; i < len; i++) {
        exports.FoundationASCIIConversion[exports.FoundationWhiteSpaces.charAt(i)] = ' ';
    }
}
function _whiteSpacesAsNumberSet(reference) {
    let ret = new Set();
    const len = reference.length;
    for (let i = 0; i < len; i++) {
        ret.add(reference.charCodeAt(i));
    }
    return ret;
}
function _whiteSpaceAsStringSet(reference) {
    let ret = new Set();
    const len = reference.length;
    for (let i = 0; i < len; i++) {
        ret.add(reference.charAt(i));
    }
    return ret;
}
exports.FoundationEncodingsAliases = [
    { name: 'ascii', aliases: ['ASCII'] },
    { name: 'latin1', aliases: [
            'bin', 'BIN', 'binary', 'BINARY',
            'LATIN1', 'latin-1', 'LATIN-1', 'latin_1', 'LATIN_1',
            'iso-latin1', 'ISO-LATIN1', 'isolatin1', 'ISOLATIN1', 'ISOLatin1',
            'iso-8859-1', 'ISO-8859-1', '8859-1', 'ISO_8859-1', "ISO8859-1",
            'iso-ir-100',
            '819', 'cp819', 'CP819', 'IBM819',
            'l1',
            'csISOLatin1',
            'ansicpg819', '\\ansicpg819'
        ] },
    { name: 'utf8', aliases: ['UTF8', 'utf-8', 'UTF-8', 'utf_8', 'UTF_8'] },
    { name: 'utf16le', aliases: [
            'UTF16', 'utf16', 'utf-16', 'utf_16', 'UTF-16', 'UTF_16',
            'ucs2', 'ucs-2', 'ucs_2', 'UCS2', 'UCS-2', 'UCS_2',
            'unicode', 'UNICODE',
            'utf-16le', 'UTF-16LE', 'utf_16le', 'UTF_16LE', 'UTF16LE'
        ] },
    { name: 'base64', aliases: ['BASE64'] },
    { name: 'base64url', aliases: ['BASE64URL', 'base64-url', 'BASE64-URL', 'base64_url', 'BASE64_URL'] },
    { name: 'hex', aliases: ['HEX', 'hexa', 'HEXA', 'hexadecimal', 'HEXADECIMAL'] }
];
function _foundationStringEncodings(definitions) {
    let ret = new Map;
    definitions.forEach(d => {
        ret.set(d.name, d.name);
        d.aliases.forEach(a => { ret.set(a, d.name); });
    });
    return ret;
}
exports.FoundationStringEncodingsMap = _foundationStringEncodings(exports.FoundationEncodingsAliases);
exports.FoundationHTMLEncoding = [
    "", "", "", "", "", "", "", "",
    "", "\u0009", "\u000a", "\u000b", "\u000c", "\u000d", "\u000e", "\u000f",
    "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "",
    " ", "!", "&quot;", "#", "$", "%", "&amp;", "'",
    "(", ")", "*", "+", ",", "-", ".", "/",
    "0", "1", "2", "3", "4", "5", "6", "7",
    "8", "9", ":", ";", "&lt;", "=", "&gt;", "?",
    "@", "A", "B", "C", "D", "E", "F", "G",
    "H", "I", "J", "K", "L", "M", "N", "O",
    "P", "Q", "R", "S", "T", "U", "V", "W",
    "X", "Y", "Z", "[", "\\", "]", "^", "_",
    "`", "a", "b", "c", "d", "e", "f", "g",
    "h", "i", "j", "k", "l", "m", "n", "o",
    "p", "q", "r", "s", "t", "u", "v", "w",
    "x", "y", "z", "{", "|", "}", "~", "",
    "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "",
    "&nbsp;", "&iexcl;", "&cent;", "&pound;", "&curren;", "&yen;", "&brvbar;", "&sect;",
    "&uml;", "&copy;", "&ordf;", "&laquo;", "&not;", "&shy;", "&reg;", "&macr;",
    "&deg;", "&plusmn;", "&sup2;", "&sup3;", "&acute;", "&micro;", "&para;", "&middot;",
    "&cedil;", "&sup1;", "&ordm;", "&raquo;", "&frac14;", "&frac12;", "&frac34;", "&iquest;",
    "&Agrave;", "&Aacute;", "&Acirc;", "&Atilde;", "&Auml;", "&Aring;", "&AElig;", "&Ccedil;",
    "&Egrave;", "&Eacute;", "&Ecirc;", "&Euml;", "&Igrave;", "&Iacute;", "&Icirc;", "&Iuml;",
    "&ETH;", "&Ntilde;", "&Ograve;", "&Oacute;", "&Ocirc;", "&Otilde;", "&Ouml;", "&times;",
    "&Oslash;", "&Ugrave;", "&Uacute;", "&Ucirc;", "&Uuml;", "&Yacute;", "&THORN;", "&szlig;",
    "&agrave;", "&aacute;", "&acirc;", "&atilde;", "&auml;", "&aring;", "&aelig;", "&ccedil;",
    "&egrave;", "&eacute;", "&ecirc;", "&euml;", "&igrave;", "&iacute;", "&icirc;", "&iuml;",
    "&eth;", "&ntilde;", "&ograve;", "&oacute;", "&ocirc;", "&otilde;", "&ouml;", "&divide;",
    "&oslash;", "&ugrave;", "&uacute;", "&ucirc;", "&uuml;", "&yacute;", "&thorn;", "&yuml;"
];
exports.FoundationHTMLStructureEncoding = [...exports.FoundationHTMLEncoding];
exports.FoundationHTMLStructureEncoding[0x22] = '"';
exports.FoundationHTMLStructureEncoding[0x26] = '&';
exports.FoundationHTMLStructureEncoding[0x3c] = '<';
exports.FoundationHTMLStructureEncoding[0x3e] = '>';
//# sourceMappingURL=string_tables.js.map