import { Locales } from './tsdefaults';
import { TSClone, TSLeafInspect, TSObject } from './tsobject';
import { Comparison, continent, country, currency, language, Nullable, StringTranslation } from './types';
import { PhonePlan } from './tsphonenumber';
declare const customInspectSymbol: unique symbol;
export declare class TSCountry implements TSObject, TSLeafInspect, TSClone<TSCountry> {
    private static __countriesMap;
    private static __countriesAlpha3Map;
    private static __countriesAlpha2Map;
    private static __countries;
    private static __dialCodeMap;
    private static __EULocale;
    readonly continent: continent;
    readonly alpha2Code: country;
    readonly alpha3Code: string;
    readonly names: StringTranslation;
    readonly nativeLanguage: language;
    readonly spokenLanguages: language[];
    readonly domains: string[];
    readonly EEC: boolean;
    readonly phonePlan: PhonePlan;
    readonly currency: currency;
    readonly locales: Locales;
    private _vatValidator?;
    private _state?;
    private constructor();
    static loadCountries(localesMap: Map<string, Locales>, managedLanguages: language[]): Map<string, TSCountry>;
    static countriesForDialCode(dc: Nullable<string>): TSCountry[];
    static country(c: Nullable<country | string>): TSCountry | null;
    static alpha2CodeForAlpha3Code(c: Nullable<string>): country | null;
    static alpha3CodeForAlpha2Code(c: Nullable<country | string>): string | null;
    static alpha2Codes(): country[];
    static alpha3Codes(): string[];
    static countryForVATNumber(vatNumber: Nullable<string>): TSCountry | null;
    static countries(): TSCountry[];
    get label(): string;
    get name(): string;
    get nativeName(): string;
    get continentLabel(): string;
    get continentName(): string | null;
    get nativeContinentName(): string | null;
    get language(): language;
    get languageName(): string;
    get nativeLanguageName(): string;
    get state(): TSCountry;
    clone(): TSCountry;
    translatedName(lang?: Nullable<language>): string | null;
    validateVATNumber(vatNumber: Nullable<string>): Nullable<string>;
    toString(): string;
    toJSON(): any;
    toArray(): string[];
    isEqual(other: any): boolean;
    compare(other: any): Comparison;
    leafInspect(): string;
    [customInspectSymbol](depth: number, inspectOptions: any, inspect: any): string;
    private static CountriesVATInfo;
}
export {};
