import { Locales } from "./tsdefaults";
import { TSDate } from "./tsdate";
import { country, int, language, Nullable, uint } from "./types";
import { TSCountry } from "./tscountry";
export interface TimeComp {
    hour: uint;
    minute: uint;
    second: uint;
}
export interface TSDateComp extends TimeComp {
    year: uint;
    month: uint;
    day: uint;
    dayOfWeek?: uint;
}
export interface TSDurationComp {
    days: uint;
    hours: uint;
    minutes: uint;
    seconds: uint;
}
export declare enum TSDateForm {
    Standard = 0,
    English = 1,
    Computer = 2,
    ISO8601 = 3,
    ISO8601C = 4,
    ISO8601L = 5
}
export type TSIsoDateForm = TSDateForm.ISO8601 | TSDateForm.ISO8601C | TSDateForm.ISO8601L;
export declare enum TSDateRep {
    LocalTime = "lt",
    LocalDate = "ld",
    LocalDateTime = "ldt",
    ShortLocalDate = "sld",
    ShortLocalDateTime = "sldt"
}
export declare function $timecomponents(source: Nullable<number | Date | TSDate>): TimeComp;
export declare function $components(source: Nullable<number | Date | TSDate>): TSDateComp;
export declare function $componentsarevalid(comp: Nullable<TSDateComp>): boolean;
export declare function $componentshavetime(c: TSDateComp): boolean;
export declare function $parsetime(s: Nullable<string>): TimeComp | null;
export declare function $parsedatetime(s: Nullable<string>, form?: TSDateForm): TSDateComp | null;
export declare function $parsedate(s: Nullable<string>, form?: TSDateForm): TSDateComp | null;
export interface Iso8601ParseOptions {
    noTime?: boolean;
}
export declare function $isostring2components(source: Nullable<string>, opts?: Iso8601ParseOptions): TSDateComp | null;
export declare function $components2timestamp(c: TSDateComp): number;
export declare function $components2date(c: TSDateComp): Date;
export declare function $components2string(c: TSDateComp, form?: TSDateForm): string;
export interface $c2StrWOffsetOpts {
    form?: TSIsoDateForm;
    minutesOffset?: int;
    milliseconds?: uint;
    forceZ?: boolean;
}
export declare function $components2StringWithOffset(c: TSDateComp, opts?: $c2StrWOffsetOpts): string;
export declare function $components2stringformat(comp: TSDateComp, format?: Nullable<string | TSDateRep>, locale?: Nullable<language | country | TSCountry | Locales>): string | null;
export declare function $durationcomponents(duration: Nullable<number>): TSDurationComp;
export declare function $duration(comps: TSDurationComp): number;
export declare function $duration2String(comps: TSDurationComp, format?: Nullable<string>): string;
export type TSTimeDescriptionDepth = 'days' | 'days-cut' | 'hours' | 'hours-cut' | 'minutes' | 'minutes-cut' | 'seconds';
export type TSDurationDescriptionDepth = TSTimeDescriptionDepth;
export interface $durationDescriptionOptions {
    depth?: Nullable<TSDurationDescriptionDepth>;
    locale?: Nullable<language | country | TSCountry | Locales>;
    noDays?: Nullable<boolean>;
}
export declare function $durationDescription(comps: TSDurationComp | number, opts?: Nullable<$durationDescriptionOptions>): string;
export declare function $durationNumber2StringFormat(duration: Nullable<number>, format?: Nullable<string>): string;
