import { TSLeafInspect } from "./tsobject";
import { Resp } from "./tsrequest";
import { Nullable, TSDictionary } from "./types";
export declare class TSUniqueError extends Error implements TSLeafInspect {
    private static __timeoutInstance;
    private static __genericInstance;
    private constructor();
    static genericError(): TSUniqueError;
    static timeoutError(): TSUniqueError;
    leafInspect(): string;
}
export declare class TSError extends Error {
    readonly info: TSDictionary | undefined;
    static readonly DefaultMessage = "TSError did throw";
    protected _errorCode: number;
    static throw(message: string): never;
    static throw(message: string, errorCode: Nullable<number | TSDictionary>): never;
    static throw(message: string, info: Nullable<TSDictionary>, errorCode: Nullable<number>): never;
    static throw(message: string, errorCode: Nullable<number>, info: Nullable<TSDictionary>): never;
    static assert(condition: boolean): void;
    static assert(condition: boolean, message: string): void;
    static assert(condition: boolean, message: string, errorCode: Nullable<number | TSDictionary>): void;
    static assert(condition: boolean, message: string, info: Nullable<TSDictionary>, errorCode: Nullable<number>): void;
    static assert(condition: boolean, message: string, errorCode: Nullable<number>, info: Nullable<TSDictionary>): void;
    constructor(message: string);
    constructor(message: string, info: Nullable<number | TSDictionary>);
    constructor(message: string, info: Nullable<TSDictionary>, errorCode: Nullable<number>);
    constructor(message: string, errorCode: Nullable<number>, info: Nullable<TSDictionary>);
    static assertIntParam(v: Nullable<number>, fn: string, param: string): void;
    static assertUnsignedParam(v: Nullable<number>, fn: string, param: string): void;
    static assertNotInBrowser(fn: string): void;
    get errorCode(): number;
    set errorCode(code: Nullable<number>);
    get status(): Resp;
    set status(s: Resp);
    entries(): [string, any][];
}
export { TSError as TSHttpError };
export declare function $subclassReponsabililty(instance: object, method: Function): any;
