import { TSClone, TSLeafInspect, TSObject } from "./tsobject";
import { Comparison, Nullable } from "./types";
export interface TSPoint {
    x: number;
    y: number;
}
export interface TSSize {
    w: number;
    h: number;
}
export declare enum TSRectEdge {
    TSMinXEdge = 0,
    TSMinYEdge = 1,
    TSMaxXEdge = 2,
    TSMaxYEdge = 3
}
export type TSDocumentFormat = 'min' | 'max' | '4a0' | '2a0' | 'a0+' | 'a0' | 'a1+' | 'a1' | 'a2' | 'a3+' | 'a3' | 'a4' | 'a5' | 'a6' | 'a7' | 'a8' | 'a9' | 'a10' | 'a11' | 'a12' | 'a13' | 'b0+' | 'b0' | 'b1+' | 'b1' | 'b2+' | 'b2' | 'b3' | 'b4' | 'b5' | 'b6' | 'b7' | 'b8' | 'b9' | 'b10' | 'b11' | 'b12' | 'b13' | 'c0' | 'c1' | 'c2' | 'c3' | 'c4' | 'c5' | 'c6' | 'c7' | 'c8' | 'c9' | 'c10' | 'ra0' | 'ra1' | 'ra2' | 'ra3' | 'ra4' | 'sra0' | 'sra1' | 'sra2' | 'sra3' | 'sra4' | 'sra1+' | 'sra2+' | 'sra3+' | 'sra3++' | 'a0u' | 'a1u' | 'a2u' | 'a3u' | 'a4u' | '4a0-landscape' | '2a0-landscape' | 'a0+landscape' | 'a0-landscape' | 'a1+landscape' | 'a1-landscape' | 'a2-landscape' | 'a3+landscape' | 'a3-landscape' | 'a4-landscape' | 'a5-landscape' | 'a6-landscape' | 'a7-landscape' | 'a8-landscape' | 'a9-landscape' | 'a10-landscape' | 'a11-landscape' | 'a12-landscape' | 'a13-landscape' | 'b0+landscape' | 'b0-landscape' | 'b1+landscape' | 'b1-landscape' | 'b2+landscape' | 'b2-landscape' | 'b3-landscape' | 'b4-landscape' | 'b5-landscape' | 'b6-landscape' | 'b7-landscape' | 'b8-landscape' | 'b9-landscape' | 'b10-landscape' | 'b11-landscape' | 'b12-landscape' | 'b13-landscape' | 'c0-landscape' | 'c1-landscape' | 'c2-landscape' | 'c3-landscape' | 'c4-landscape' | 'c5-landscape' | 'c6-landscape' | 'c7-landscape' | 'c8-landscape' | 'c9-landscape' | 'c10-landscape' | 'ra0-landscape' | 'ra1-landscape' | 'ra2-landscape' | 'ra3-landscape' | 'ra4-landscape' | 'sra0-landscape' | 'sra1-landscape' | 'sra2-landscape' | 'sra3-landscape' | 'sra4-landscape' | 'sra1+landscape' | 'sra2+landscape' | 'sra3+landscape' | 'sra3++landscape' | 'a0u-landscape' | 'a1u-landscape' | 'a2u-landscape' | 'a3u-landscape' | 'a4u-landscape' | 'letter' | 'legal' | 'tabloid' | 'gov-letter' | 'gov-legal' | 'half-letter' | 'junior-legal' | 'arch-a' | 'arch-b' | 'arch-c' | 'arch-d' | 'arch-e' | 'arch-e1' | 'arch-e2' | 'arch-e3' | 'ansi-c' | 'ansi-d' | 'ansi-e' | 'letter-landscape' | 'legal-landscape' | 'ledger' | 'gov-letter-landscape' | 'gov-legal-landscape' | 'half-letter-landscape' | 'junior-legal-landscape' | 'arch-a-landscape' | 'arch-b-landscape' | 'arch-c-landscape' | 'arch-d-landscape' | 'arch-e-landscape' | 'arch-e1-landscape' | 'arch-e2-landscape' | 'arch-e3-landscape' | 'ansi-c-landscape' | 'ansi-d-landscape' | 'ansi-e-landscape' | 'raisin' | 'demi-raisin' | 'double-raisin' | 'jesus' | 'soleil' | 'univers' | 'raisin-landscape' | 'demi-raisin-landscape' | 'double-raisin-landscape' | 'jesus-landscape' | 'soleil-landscape' | 'univers-landscape' | 'din-d0' | 'din-d1' | 'din-d2' | 'din-d3' | 'din-d4' | 'din-d5' | 'din-d6' | 'din-d7' | 'din-d8' | 'din-d0-landscape' | 'din-d1-landscape' | 'din-d2-landscape' | 'din-d3-landscape' | 'din-d4-landscape' | 'din-d5-landscape' | 'din-d6-landscape' | 'din-d7-landscape' | 'din-d8-landscape' | 'envelope-dl' | 'envelope-b4' | 'envelope-b5' | 'envelope-b6' | 'envelope-c3' | 'envelope-c4' | 'envelope-c4m' | 'envelope-c5' | 'envelope-c6/c5' | 'envelope-c6' | 'envelope-c64m' | 'envelope-c7/c6' | 'envelope-c7' | 'envelope-ce4' | 'envelope-ce64' | 'envelope-e4' | 'envelope-ec45' | 'envelope-ec5' | 'envelope-e5' | 'envelope-e56' | 'envelope-e6' | 'envelope-e65' | 'envelope-r7' | 'envelope-s4' | 'envelope-s5' | 'envelope-s65' | 'envelope-x5' | 'envelope-ex5' | 'folio' | 'quarto' | 'octavo' | 'a-format' | 'b-format' | 'c-format' | 'folio-landscape' | 'quarto-landscape' | 'octavo-landscape' | 'a-format-landscape' | 'b-format-landscape' | 'c-format-landscape';
export declare const TSDocumentFormats: {
    [key in TSDocumentFormat]: TSSize;
};
declare const customInspectSymbol: unique symbol;
export interface TSFrame extends TSPoint, TSSize {
}
export declare class TSRect implements TSFrame, TSObject, TSLeafInspect, TSClone<TSRect> {
    x: number;
    y: number;
    w: number;
    h: number;
    constructor();
    constructor(rect: TSRect);
    constructor(frame: TSFrame);
    constructor(format: TSDocumentFormat);
    constructor(arrayRect: number[]);
    constructor(x: number, y: number, w: number, h: number);
    constructor(origin: TSPoint, w: number, h: number);
    constructor(x: number, y: number, size: TSSize | TSDocumentFormat);
    constructor(origin: TSPoint, size: TSSize | TSDocumentFormat);
    get origin(): TSPoint;
    get size(): TSSize;
    get width(): number;
    get height(): number;
    get frame(): TSFrame;
    get minX(): number;
    get minY(): number;
    get maxX(): number;
    get maxY(): number;
    get midX(): number;
    get midY(): number;
    get isEmpty(): boolean;
    contains(p: Nullable<TSPoint | TSRect | number[]>): boolean;
    containsPoint(p: Nullable<TSPoint | number[]>): boolean;
    containsRect(p: Nullable<TSRect | number[]>): boolean;
    containedIn(r: Nullable<TSRect | number[]>): boolean;
    containedInRect: (r: Nullable<TSRect | number[]>) => boolean;
    intersects(r: Nullable<TSRect | number[]>): boolean;
    intersectsRect: (r: Nullable<TSRect | number[]>) => boolean;
    intersection(r: Nullable<TSRect | number[]>): TSRect;
    intersectionRect: (r: Nullable<TSRect | number[]>) => TSRect;
    union(r: Nullable<TSRect | number[]>): TSRect;
    unionRect: (r: Nullable<TSRect | number[]>) => TSRect;
    offset(xOffset: number, yOffset: number): TSRect;
    offsetRect: (xOffset: number, yOffset: number) => TSRect;
    inset(insetWidth: number, insetHeight: number): TSRect;
    insetRect: (insetWidth: number, insetHeight: number) => TSRect;
    integral(): TSRect;
    integralRect: () => TSRect;
    divide(amount: number, edge: TSRectEdge): [TSRect, TSRect];
    divideRect: (amount: number, edge: TSRectEdge) => [TSRect, TSRect];
    clone(): TSRect;
    closedPolygon(updatesYCoordinatesfirst?: boolean): TSPoint[];
    isEqual(other: any): boolean;
    compare(other: any): Comparison;
    toJSON(): TSFrame;
    toString(): string;
    toArray(): number[];
    leafInspect: () => string;
    [customInspectSymbol](depth: number, inspectOptions: any, inspect: any): string;
    _setInternalValues(message: string, x: any, y: any, w: any, h: any, _moreTest?: boolean): void;
}
export declare function TSmm2Pixels(mm: number): number;
export declare function TScm2Pixels(cm: number): number;
export declare function TSPixels2cm(pixels: number): number;
export declare function TSPixels2mm(pixels: number): number;
export declare function TSInches2Pixels(inches: number): number;
export declare function TSPixels2Inches(pixels: number): number;
export declare function TSEqualPoints(A: TSPoint, B: TSPoint): boolean;
export declare function TSEqualSizes(A: TSSize, B: TSSize): boolean;
export declare function TSArea(A: TSSize): number;
export declare function TSValidSize(A: Nullable<TSSize>): boolean;
export declare function TSCompareSizes(A: TSSize, B: TSSize): Comparison;
export interface TSAssertFormatOptions {
    defaultSize?: TSSize;
    minimalSize?: TSSize;
    maximalSize?: TSSize;
    invalidSizeRaise?: boolean;
    undersizeRaise?: boolean;
    oversizeRaise?: boolean;
}
export declare function TSAssertFormat(format: Nullable<TSDocumentFormat | TSSize>, opts?: TSAssertFormatOptions): TSSize;
export declare const TSCM: number;
export declare const TSMM: number;
export declare const TSIN: number;
export declare function $comformsToPoint(v: any): boolean;
export declare function $conformsToSize(v: any): boolean;
export declare function $conformsToFrame(v: any): boolean;
export {};
