import { TSCountry } from "./tscountry";
import { TSClone, TSLeafInspect, TSObject } from "./tsobject";
import { Comparison, Nullable } from "./types";
declare const customInspectSymbol: unique symbol;
export interface PhonePlanInfo {
    dialCode: string;
    trunkCode: string;
    areaCodes?: string[];
    minDigits?: number;
    maxDigits?: number;
}
export type PhonePlan = Required<PhonePlanInfo>;
export declare enum PhoneValidity {
    OK = 0,
    WrongLength = 1,
    MalformedNumber = 2,
    BadCountryNumber = 3,
    CountryNotFound = 4,
    MixedCountries = 5
}
export declare class TSPhoneNumber implements TSObject, TSLeafInspect, TSClone<TSPhoneNumber> {
    readonly number: string;
    readonly country: TSCountry;
    static fromString(source: Nullable<string>, telcountry?: Nullable<TSCountry>): TSPhoneNumber | null;
    static interpret(source: Nullable<string>, telcountry?: Nullable<TSCountry>): TSPhoneNumber | PhoneValidity;
    static validity(source: Nullable<string>, telcountry?: Nullable<TSCountry>): PhoneValidity;
    private constructor();
    get dialCode(): string;
    get standardNumber(): string;
    clone(): TSPhoneNumber;
    leafInspect: () => string;
    [customInspectSymbol](depth: number, inspectOptions: any, inspect: any): string;
    compare(other: any): Comparison;
    isEqual(other: any): boolean;
    toArray(): any[];
    toString: () => string;
    toJSON: () => string;
    private _standardNumber;
}
export {};
