/// <reference types="node" />
import { TSDictionary } from "./types";
import { TSEndPoint, TSEndPointController, TSEndpointsDefinition, TSServerRequest } from "./tsserver_types";
import { ServerResponse } from "http";
export declare class TSServerEndPoint {
    readonly uri: string;
    readonly depth: number;
    private _managers;
    private _pathRegex;
    private _tokens;
    constructor(path: string, definition: TSEndpointsDefinition | TSEndPoint | TSEndPointController);
    get isStatic(): boolean;
    parametersFromPath(path: string): TSDictionary | null;
    execute(req: TSServerRequest, res: ServerResponse): Promise<void>;
}
